local function SetupFrame(argFrame)
	argFrame:SetBackdropBorderColor(Perl_Config.BorderColour.r, Perl_Config.BorderColour.g, Perl_Config.BorderColour.b, 1);
	argFrame:SetBackdropColor(Perl_Config.BackColour.r, Perl_Config.BackColour.g, Perl_Config.BackColour.b, Perl_Config.Transparency);
end

local function SetAllFrames()
	SetupFrame(Perl_Player_Pet_StatsFrame);
	SetupFrame(Perl_Player_Pet_LevelFrame);
        SetupFrame(Perl_Player_Pet_HappyFrame);
	SetupFrame(Perl_Player_Pet_NameFrame);
	SetupFrame(Perl_Player_Pet_BuffFrame);
	Perl_Player_Pet_HealthBarText:SetTextColor(1,1,1,Perl_Config.TextTransparency);
	Perl_Player_Pet_ManaBarText:SetTextColor(1,1,1,Perl_Config.TextTransparency);

	SetupFrame(Perl_Player_StatsFrame);
	SetupFrame(Perl_Player_PortraitFrame);
	SetupFrame(Perl_Player_NameFrame);
	SetupFrame(Perl_Player_LevelFrame);
	SetupFrame(Perl_Player_GroupFrame);
	Perl_Player_ClassTexture:SetAlpha(Perl_Config.Transparency);
	Perl_Player_HealthBarText:SetTextColor(1,1,1,1);
	Perl_Player_ManaBarText:SetTextColor(1,1,1,1);
	Perl_Player_DruidBarText:SetTextColor(1,1,1,1);
	Perl_Player_HealthBarTEXT:SetTextColor(1,1,1,Perl_Config.TextTransparency);
	Perl_Player_ManaBarTEXT:SetTextColor(1,1,1,Perl_Config.TextTransparency);
	Perl_Player_XPBarText:SetTextColor(1,1,1,Perl_Config.TextTransparency);
	Perl_Player_PVPRankIcon:SetAlpha(0.3);

	SetupFrame(Perl_TargetTarget_StatsFrame);
	SetupFrame(Perl_TargetTarget_NameFrame);
	SetupFrame(Perl_TargetTarget_LevelFrame);
	--Perl_TargetTarget_Frame:Hide();
	Perl_TargetTarget_HealthBarText:SetTextColor(1,1,1,Perl_Config.TextTransparency);
	Perl_TargetTarget_ManaBarText:SetTextColor(1,1,1,Perl_Config.TextTransparency);
	Perl_TargetTarget_ManaBarPercent:SetTextColor(1,1,1,1);
	Perl_TargetTarget_HealthBarPercent:SetTextColor(1,1,1,1);

	SetupFrame(Perl_Target_StatsFrame);
	SetupFrame(Perl_Target_NameFrame);
	SetupFrame(Perl_Target_PortraitFrame);
	SetupFrame(Perl_Target_BuffFrame);
	SetupFrame(Perl_Target_LevelFrame);
        SetupFrame(Perl_Target_AssistFrame);
        --Perl_Target_AssistBarText:SetTextColor(0.5,1,0.5,1);
        SetupFrame(Perl_Player_TargettingFrame);
        --Perl_Player_TargettingBarText:SetTextColor(0.5,1,0.5,1);
	SetupFrame(Perl_Target_TypeFrame);
	SetupFrame(Perl_Target_BossFrame);
	SetupFrame(Perl_Target_Assists_Frame);

	SetupFrame(Perl_Target_CPFrame);
	--Perl_Target_Frame:Hide();
	Perl_Target_ClassTexture:SetAlpha(Perl_Config.Transparency);
	Perl_Target_HealthBarText:SetTextColor(1,1,1,Perl_Config.TextTransparency);
	Perl_Target_ManaBarText:SetTextColor(1,1,1,Perl_Config.TextTransparency);
	Perl_Target_ManaBarPercent:SetTextColor(1,1,1,1);
	Perl_Target_HealthBarPercent:SetTextColor(1,1,1,1);
	Perl_Target_PVPRankIcon:SetAlpha(0.3);
        Perl_TargetTarget_PVPRankIcon:SetAlpha(0.3);
	for num=1,4 do
		SetupFrame(getglobal("Perl_party"..num.."_StatsFrame"));
		SetupFrame(getglobal("Perl_party"..num.."_NameFrame"));
		SetupFrame(getglobal("Perl_party"..num.."_LevelFrame"));
		SetupFrame(getglobal("Perl_party"..num.."_BuffFrame"));
		getglobal("Perl_party"..num.."_LevelFrame_ClassTexture"):SetAlpha(Perl_Config.Transparency);

		getglobal("Perl_party"..num.."_StatsFrame_HealthBar_HealthBarText"):SetTextColor(1,1,1,Perl_Config.TextTransparency);
		getglobal("Perl_party"..num.."_StatsFrame_ManaBar_ManaBarText"):SetTextColor(1,1,1,Perl_Config.TextTransparency);
		getglobal("Perl_party"..num.."_StatsFrame_HealthBar_HealthBarPercentText"):SetTextColor(1,1,1,1);
		getglobal("Perl_party"..num.."_StatsFrame_ManaBar_ManaBarPercentText"):SetTextColor(1,1,1,1);

		SetupFrame(getglobal("Perl_party"..num.."_TargetFrame"));

		SetupFrame(getglobal("Perl_Party_Pet"..num.."_StatsFrame"));
		SetupFrame(getglobal("Perl_Party_Pet"..num.."_NameFrame"));
		SetupFrame(getglobal("Perl_Party_Pet"..num.."_BuffFrame"));

		getglobal("Perl_Party_Pet"..num.."_StatsFrame_HealthBar_HealthBarPercentText"):SetTextColor(1,1,1,1);
		getglobal("Perl_Party_Pet"..num.."_StatsFrame_ManaBar_ManaBarPercentText"):SetTextColor(1,1,1,1);

		if (UnitName("party"..num) and not UnitIsConnected("party"..num)) then
			getglobal("Perl_party"..num):SetAlpha(Perl_Config.Transparency / 2);
		end
	end

	for num=1,10 do
		SetupFrame(getglobal("Perl_TargetTarget_History"..num));
	end
	SetupFrame(Perl_TargetTarget_HistoryLast);
end

function Perl_Init()
	SetAllFrames();

	Perl_Player_Frame:Show();
	Perl_Player_XPBarText:Hide();
	Perl_OptionActions();
	Perl_SlashOnLoad();
end


function Perl_OptionActions()
	if (Perl_Config.ShowPlayerPortrait==0) then
		Perl_Player_Hide_Portrait();
	elseif (Perl_Config.ShowPlayerPortrait==1) then
		Perl_Player_Show_Portrait();
	end
	if (Perl_Config.ShowPlayerLevel==0) then
		Perl_Player_Hide_Level();
	elseif (Perl_Config.ShowPlayerLevel==1) then
		Perl_Player_Show_Level();
	end
	if (Perl_Config.ShowPlayerClassIcon==0) then
		Perl_Player_Hide_Class();
	elseif (Perl_Config.ShowPlayerClassIcon==1) then
		Perl_Player_Show_Class();
	end
	if (Perl_Config.ShowPlayerXPBar==0) then
		Perl_Player_Hide_XPBar();
	elseif (Perl_Config.ShowPlayerXPBar==1) then
		Perl_Player_Show_XPBar();
	end
	if (Perl_Config.ShowTargetPortrait==0) then
		Perl_Target_Hide_Portrait();
	elseif (Perl_Config.ShowTargetPortrait==1) then
		Perl_Target_Show_Portrait();
	end
	if (Perl_Config.ShowTargetClassIcon==0) then
		Perl_Target_Hide_Class();
	elseif (Perl_Config.ShowTargetClassIcon==1) then
		Perl_Target_Show_Class();
	end
	if (Perl_Config.ShowTargetMobType==0) then
		Perl_Target_Hide_Type();
	elseif (Perl_Config.ShowTargetMobType==1) then
		Perl_Target_Show_Type();
	end
	if (Perl_Config.ShowTargetLevel==0) then
		Perl_Target_Hide_Level();
	elseif (Perl_Config.ShowTargetLevel==1) then
		Perl_Target_Show_Level();
	end
	if (Perl_Config.ShowTargetElite==0) then
		Perl_Target_Hide_Elite();
	elseif (Perl_Config.ShowTargetElite==1) then
		Perl_Target_Show_Elite();
	end
	if (Perl_Config.ShowTargetMana==0) then
		Perl_Target_Hide_Mana();
	elseif (Perl_Config.ShowTargetMana==1) then
		Perl_Target_Show_Mana();
	end
	if (Perl_Config.ShowPartyClassIcon==0) then
		Perl_HidePartyIcon();
	elseif (Perl_Config.ShowPartyClassIcon==1) then
		Perl_ShowPartyIcon();
	end
	if (Perl_Config.ShowPartyLevel==0) then
		Perl_HidePartyLevel();
	elseif (Perl_Config.ShowPartyLevel==1) then
		Perl_ShowPartyLevel();
	end
	if (Perl_Config.ShowPartyNames==0) then
		Perl_HidePartyNames();
	elseif (Perl_Config.ShowPartyNames==1) then
		Perl_ShowPartyNames();
	end
	if (Perl_Config.ShowPartyPercent==0) then
		Perl_HidePartyPercent();
	elseif (Perl_Config.ShowPartyPercent==1) then
		Perl_ShowPartyPercent();
	end
	if (Perl_Config.PetHappiness==0) then
		Perl_Player_Pet_HideHappiness();
	elseif (Perl_Config.PetHappiness==1) then
		Perl_Player_Pet_ShowHappiness();
	end
	if (Perl_Config.ShowPetLevel==0) then
		Perl_Player_Pet_HideLevel();
	elseif (Perl_Config.ShowPetLevel==1) then
		Perl_Player_Pet_ShowLevel();
	end
	if (Perl_Config.ShowTargetPVPRank==0) then
		Perl_Target_Hide_Rank();
	elseif (Perl_Config.ShowTargetPVPRank==1) then
		Perl_Target_Show_Rank();
	end
	if (Perl_Config.ShowPlayerPVPRank==0) then
		Perl_Player_Hide_Rank();
	elseif (Perl_Config.ShowPlayerPVPRank==1) then
		Perl_Player_Show_Rank();
	end
	if (Perl_Config.BarTextures==0) then
		Perl_NoBarTextures();
	elseif (Perl_Config.BarTextures==1) then
		Perl_ShowBarTextures();
	end

	Perl_Config.Transparency=tonumber(Perl_Config.Transparency);
	if type(Perl_Config.Transparency) == "number" and Perl_Config.Transparency> 0 and Perl_Config.Transparency< 2.5 then

		Perl_SetTransparency(Perl_Config.Transparency);
	else
		Perl_Config.Transparency=0.8;
	end

	Perl_Config.TextTransparency=tonumber(Perl_Config.TextTransparency);
	if type(Perl_Config.TextTransparency) == "number" and Perl_Config.TextTransparency> 0 and Perl_Config.TextTransparency< 2.5 then

		Perl_SetTextTransparency(Perl_Config.TextTransparency);
	else
		Perl_Config.TextTransparency=0.8;
	end

	Perl_Config.Scale_PlayerFrame=tonumber(Perl_Config.Scale_PlayerFrame);
	if type(Perl_Config.Scale_PlayerFrame) == "number" and Perl_Config.Scale_PlayerFrame > 0 and Perl_Config.Scale_PlayerFrame< 2.5 then
		Perl_ScalePlayer(Perl_Config.Scale_PlayerFrame);
	else
		Perl_Config.Scale_PlayerFrame=0.8;
	end

	Perl_Config.Scale_PetFrame=tonumber(Perl_Config.Scale_PetFrame);
	if type(Perl_Config.Scale_PetFrame) == "number" and Perl_Config.Scale_PetFrame> 0 and Perl_Config.Scale_PetFrame< 2.5 then

		Perl_ScalePet(Perl_Config.Scale_PetFrame);
	else
		Perl_Config.Scale_PetFrame=0.8;
	end


	Perl_Config.Scale_PartyFrame=tonumber(Perl_Config.Scale_PartyFrame);
	if type(Perl_Config.Scale_PartyFrame) == "number" and Perl_Config.Scale_PartyFrame > 0 and Perl_Config.Scale_PartyFrame < 2.5 then
		Perl_ScaleParty(Perl_Config.Scale_PartyFrame);
	else
		Perl_Config.Scale_PartyFrame=0.8;
	end

	Perl_Config.Scale_TargetFrame=tonumber(Perl_Config.Scale_TargetFrame);
	if type(Perl_Config.Scale_TargetFrame) == "number" and Perl_Config.Scale_TargetFrame > 0 and Perl_Config.Scale_TargetFrame < 2.5 then
		Perl_ScaleTarget(Perl_Config.Scale_TargetFrame);
	else
		Perl_Config.Scale_TargetFrame=0.8;
	end

	Perl_Config.Scale_TargetTargetFrame=tonumber(Perl_Config.Scale_TargetTargetFrame);
	if type(Perl_Config.Scale_TargetTargetFrame) == "number" and Perl_Config.Scale_TargetTargetFrame> 0 and Perl_Config.Scale_TargetTargetFrame< 2.5 then
		Perl_ScaleTargetTarget(Perl_Config.Scale_TargetTargetFrame);
	else
		Perl_Config.Scale_TargetTargetFrame=0.8;
	end

	Perl_Config.Scale_AssistsFrame=tonumber(Perl_Config.Scale_AssistsFrame);
	if type(Perl_Config.Scale_AssistsFrame) == "number" and Perl_Config.Scale_AssistsFrame> 0 and Perl_Config.Scale_AssistsFrame< 2.5 then
		Perl_ScaleAssistFrame(Perl_Config.Scale_AssistsFrame);
	else
		Perl_Config.Scale_AssistsFrame = 0.8;
	end

--[[
	Perl_Config.Scale_Raid=tonumber(Perl_Config.Scale_Raid);
	if type(Perl_Config.Scale_Raid) == "number" and Perl_Config.Scale_Raid> 0 and Perl_Config.Scale_Raid< 2.5 then

		Perl_ScaleRaid(Perl_Config.Scale_Raid);
	else
		Perl_Config.Scale_Raid=0.8;
	end
]]

	if (Perl_Config.ArcaneBar==0) then
		Perl_ArcaneBar_Hide();
	elseif (Perl_Config.ArcaneBar==1) then
		Perl_ArcaneBar_Show();
	end
	if (Perl_Config.OldCastBar==0) then
		Perl_OldCastBar_Hide();
	elseif (Perl_Config.OldCastBar==1) then
		Perl_OldCastBar_Show();
	end
	if (Perl_Config.ShowOldPlayerFrame==0) then
		Perl_HideBlizzardPlayer();
	elseif (Perl_Config.ShowOldPlayerFrame==1) then
		Perl_ShowBlizzardPlayer();
	end
	if (Perl_Config.CastPartyShow==0) then
		Perl_HideCastParty();
	elseif (Perl_Config.CastPartyShow==1) then
		Perl_ShowCastParty();
	end
	if (Perl_Config.BarTextures==1) then
		Perl_ShowBarTextures();
	elseif (Perl_Config.BarTextures==0) then
		Perl_NoBarTextures();
	end

	for i = 1,4 do
		local frame = getglobal("Perl_Party_Pet"..i);
		Perl_Party_Pet_UpdateDisplay(frame);
	end

	Perl_Player_UpdateLeader();
end

function Perl_RegisterMCom()
    if (MCom and Khaos) then
	--Register a seperator, specifying section, and main super slash command
	MCom.registerSmart( {
                uifolder = "frames";                                    --The folder to use in Khaos
                default = true;
                uisec = "Perl";                                         --The section/set to use in the UI
                uiseclabel = Perl_Description;                          --The section/set label
                uisecdesc = PERL_CONF_OPTIONS;                          --The section/set description
                uisecdiff = 1;                                          --The section/set difficulty
                uiver = Perl_VersionNumber;                             --The version number to display in the UI
                uiframe = "Perl_Player_Frame";                          --The frame to identify this addon by
                supercom = {"/perl"};                                   --The main slash command, and any aliases for it
                comaction = "before";                                   --See Sky for info on this
                comsticky = false;                                      --See Sky for info on this
                comhelp = "/perl";                                      --The help text to show for the slash command
                name = Perl_Version;					--The name of the addon, for display in the info text
                uiauthor = "Zek";
                uiwww = "http://www.url.com/";
                uimail = "zeksie@ntlworld.com";
                uidiff = 1;                                             --The difficulty of the option
		mcomtable = {
			{
                                uivar = "PerlSeparator";                        --The option name for the UI
                                uitype = K_HEADER;                              --The option type for the UI
                                uilabel = PERL_CONF_GLOBAL_OPTIONS;             --The label to use for the seperator in the UI
                                uidesc = PERL_CONF_GLOBAL_OPTIONS_DESC;         --The description to use for the seperator in the UI
			};
                        --Register a button, and a boolean sub slash command for lock
                        {
                                uivar = "PerlLockFrames";                       --The option name for the UI
                                uitype = K_BUTTON;                              --The option type for the UI
                                uitext = PERL_CONF_LOCK_FRAMES;
                                uilabel = PERL_CONF_LOCK_FRAMES;                --The label to use for the button in the UI
                                uidesc = PERL_CONF_LOCK_FRAMES_DESC;
                                subcom = {"lock"};                              --The sub slash command and any aliases for this option
                                subhelp = PERL_CONF_LOCK_FRAMES_DESC;           --The help text for the sub slash command
                                func=function() perl_locked=1; end;
                        };
                        --Register a button, and a boolean sub slash command for unlock
                        {
                                uivar = "PerlUnlockFrames";                     --The option name for the UI
                                uitype = K_BUTTON;                              --The option type for the UI
                                uitext = PERL_CONF_UNLOCK_FRAMES;
                                uilabel = PERL_CONF_UNLOCK_FRAMES;              --The label to use for the button in the UI
                                uidesc = PERL_CONF_UNLOCK_FRAMES_DESC;
                                subcom = {"unlock"};                            --The sub slash command and any aliases for this option
                                subhelp = PERL_CONF_UNLOCK_FRAMES_DESC;         --The help text for the sub slash command
                                func=function() perl_locked=0; end;
                        };
                        --Register a checkbox, and a boolean sub slash command for ArcaneBar
			{
                                hasbool = true;                                 --Whether this options has a boolean part
                                uivar = "PerlArcaneBar";                        --The option name for the UI
                                uitype = K_TEXT;                                --The option type for the UI
                                uilabel = PERL_CONF_ARCANE_BAR;                 --The label to use for the checkbox in the UI
                                uidesc = PERL_CONF_ARCANE_BAR_DESC;             --The description to use for the checkbox in the UI
                                varbool = "Perl_Config.ArcaneBar";              --The boolean variable associate with this option
                                uicheck = Perl_Config.ArcaneBar;                --The default value for the checkbox in the UI
                                update = Perl_OptionActions;                    --A command to perform when the option is succesfully updated
                                subcom = {"arcanebar"};                         --The sub slash command and any aliases for this option
                                subhelp = PERL_CONF_ARCANE_BAR_DESC;            --The help text for the sub slash command
			};
                        --Register a checkbox, and a boolean sub slash command for OriginalCastBar
			{
                                hasbool = true;                                 --Whether this options has a boolean part
                                uivar = "OriginalCastBar";                      --The option name for the UI
                                uitype = K_TEXT;                                --The option type for the UI
                                uilabel = PERL_CONF_ORIGINAL_CASTBAR;           --The label to use for the checkbox in the UI
                                uidesc = PERL_CONF_ORIGINAL_CASTBAR_DESC;       --The description to use for the checkbox in the UI
                                varbool = "Perl_Config.OldCastBar";             --The boolean variable associate with this option
                                uicheck = Perl_Config.OldCastBar;               --The default value for the checkbox in the UI
                                update = Perl_OptionActions;                    --A command to perform when the option is succesfully updated
                                subcom = {"oldcastbar"};                        --The sub slash command and any aliases for this option
                                subhelp = PERL_CONF_ORIGINAL_CASTBAR_DESC;      --The help text for the sub slash command
			};
                        --Register a checkbox, and a boolean sub slash command for CastTime
			{
                                hasbool = true;                                 --Whether this options has a boolean part
                                uivar = "PerlCastTime";                         --The option name for the UI
                                uitype = K_TEXT;                                --The option type for the UI
                                uilabel = PERL_CONF_CAST_TIME;                  --The label to use for the checkbox in the UI
                                uidesc = PERL_CONF_CAST_TIME_DESC;              --The description to use for the checkbox in the UI
                                varbool = "Perl_Config.CastTime";               --The boolean variable associate with this option
                                uicheck = Perl_Config.CastTime;                 --The default value for the checkbox in the UI
                                update = Perl_OptionActions;                    --A command to perform when the option is succesfully updated
                                subcom = {"casttime"};                          --The sub slash command and any aliases for this option
                                subhelp = PERL_CONF_CAST_TIME_DESC;             --The help text for the sub slash command
			};
                        --Register a checkbox, and a boolean sub slash command for BarTexture
			{
                                hasbool = true;                                 --Whether this options has a boolean part
                                uivar = "PerlBarTexture";                       --The option name for the UI
                                uitype = K_TEXT;                                --The option type for the UI
                                uilabel = PERL_CONF_BAR_TEXTURES;               --The label to use for the checkbox in the UI
                                uidesc = PERL_CONF_BAR_TEXTURES_DESC;           --The description to use for the checkbox in the UI
                                varbool = "Perl_Config.BarTextures";            --The boolean variable associate with this option
                                uicheck = Perl_Config.BarTextures;              --The default value for the checkbox in the UI
                                update = Perl_OptionActions;                    --A command to perform when the option is succesfully updated
                                subcom = {"bartextures"};                       --The sub slash command and any aliases for this option
                                subhelp = PERL_CONF_BAR_TEXTURES_DESC;          --The help text for the sub slash command
			};
                        --Register a checkbox, and a boolean sub slash command for Player 3D Portrait
			{
                                hasbool = true;                                 --Whether this options has a boolean part
                                uivar = "PerlPlayerPortrait3D";			--The option name for the UI
                                uitype = K_TEXT;                                --The option type for the UI
                                uilabel = PERL_CONF_PLAYER_PORTRAIT3D;		--The label to use for the checkbox in the UI
                                uidesc = PERL_CONF_PLAYER_PORTRAIT3D_DESC;	--The description to use for the checkbox in the UI
                                varbool = "Perl_Config.ShowPlayerPortrait3D";	--The boolean variable associate with this option
                                uicheck = Perl_Config.ShowPlayerPortrait3D;	--The default value for the checkbox in the UI
                                update = Perl_OptionActions;                    --A command to perform when the option is succesfully updated
                                subcom = {"portrait3d", "3d"};			--The sub slash command and any aliases for this option
                                subhelp = PERL_CONF_PLAYER_PORTRAIT3D_DESC;	--The help text for the sub slash command
			};
                        --Register a checkbox, and a boolean sub slash command for Player 3D Portrait
			{
                                hasbool = true;                                 --Whether this options has a boolean part
                                uivar = "PerlCombatFlash";			--The option name for the UI
                                uitype = K_TEXT;                                --The option type for the UI
                                uilabel = PERL_CONF_COMBAT_FLASH;		--The label to use for the checkbox in the UI
                                uidesc = PERL_CONF_COMBAT_FLASH_DESC;		--The description to use for the checkbox in the UI
                                varbool = "Perl_Config.PerlCombatFlash";	--The boolean variable associate with this option
                                uicheck = Perl_Config.PerlCombatFlash;		--The default value for the checkbox in the UI
                                subcom = {"portrait3d", "3d"};			--The sub slash command and any aliases for this option
                                subhelp = PERL_CONF_COMBAT_FLASH_DESC;		--The help text for the sub slash command
			};
                        --Register a checkbox, and a boolean sub slash command for TargetsTarget
			{
                                hasbool = true;                                 --Whether this options has a boolean part
                                uivar = "TargetsTarget";                        --The option name for the UI
                                uitype = K_TEXT;                                --The option type for the UI
                                uilabel = PERL_CONF_TARGETS_TARGET;             --The label to use for the checkbox in the UI
                                uidesc = PERL_CONF_TARGETS_TARGET_DESC;         --The description to use for the checkbox in the UI
                                varbool = "Perl_Config.ShowTargetTarget";       --The boolean variable associate with this option
                                uicheck = Perl_Config.ShowTargetTarget;         --The default value for the checkbox in the UI
                                update = Perl_OptionActions;                    --A command to perform when the option is succesfully updated
                                subcom = {"targettarget"};                      --The sub slash command and any aliases for this option
                                subhelp = PERL_CONF_TARGETS_TARGET_DESC;        --The help text for the sub slash command
			};
                        --Register a checkbox, and a boolean sub slash command for TargetsTarget History
			{
                                hasbool = true;                                 --Whether this options has a boolean part
                                uivar = "TargetsTargetHistory";			--The option name for the UI
                                uidep = { ["TargetsTarget"] = { checked = true } };
                                uitype = K_TEXT;                                --The option type for the UI
                                uilabel = PERL_CONF_TARGETS_HISTORY;		--The label to use for the checkbox in the UI
                                uidesc = PERL_CONF_TARGETS_HISTORY_DESC;	--The description to use for the checkbox in the UI
                                varbool = "Perl_Config.TargetTargetHistory";	--The boolean variable associate with this option
                                uicheck = Perl_Config.TargetTargetHistory;	--The default value for the checkbox in the UI
                                update = Perl_OptionActions;                    --A command to perform when the option is succesfully updated
                                subcom = {"targethistory"};			--The sub slash command and any aliases for this option
                                subhelp = PERL_CONF_TARGETS_HISTORY_DESC;	--The help text for the sub slash command
			};
                        --Register a slider, and a number sub slash command for FrameTransparecny
			{
                                uivar = "FrameTransparency";                    --The option name for the UI
                                uitype = K_SLIDER;                              --The option type for the UI
                                uilabel = PERL_CONF_FRAME_TRANSPARENCY;         --The label to use for the checkbox in the UI
                                uidesc = PERL_CONF_FRAME_TRANSPARENCY_DESC;     --The description to use for the checkbox in the UI
                                varnum = "Perl_Config.Transparency";            --The number variable associate with this option
                                uislider = Perl_Config.Transparency;            --The default value for the checkbox in the UI
                                textname = PERL_CONF_FRAME_TRANSPARENCY_CHANGED; --What to say when the command is successfully updated, and there is no GUI
                                update = Perl_OptionActions;                    --A command to perform when the option is succesfully updated
				uimin = 0;
				uimax = 1;
                                uitext = "uitext";
				uistep = 0.01;
				uitexton = 1;
                                uisuffix = "%";
				uimul = 100;
                                subcom = {"settrans", "ft"};                    --The sub slash command and any aliases for this option
                                subhelp = PERL_CONF_FRAME_TRANSPARENCY_DESC;    --The help text for the sub slash command
			};
                        --Register a slider, and a number sub slash command for TextTransparecny
			{
                                uivar = "TextTransparecny";                     --The option name for the UI
                                uitype = K_SLIDER;                              --The option type for the UI
                                uilabel = PERL_CONF_TEXT_TRANSPARENCY;          --The label to use for the checkbox in the UI
                                uidesc = PERL_CONF_TEXT_TRANSPARENCY_DESC;      --The description to use for the checkbox in the UI
                                varnum = "Perl_Config.TextTransparency";        --The number variable associate with this option
                                uislider = Perl_Config.TextTransparency;        --The default value for the checkbox in the UI
                                textname = PERL_CONF_TEXT_TRANSPARENCY_CHANGED; --What to say when the command is successfully updated, and there is no GUI
                                update = Perl_OptionActions;                    --A command to perform when the option is succesfully updated
				uimin = 0;
				uimax = 1;
                                uitext = "uitext";
				uistep = 0.01;
				uitexton = 1;
                                uisuffix = "%";
				uimul = 100;
                                subcom = {"settexttrans", "tt"};                --The sub slash command and any aliases for this option
                                subhelp = PERL_CONF_TEXT_TRANSPARENCY_DESC;     --The help text for the sub slash command
			};
			--Register a color picker, and a color sub slash command for LowManaColor
			{
				uivar = "PerlBackColour";			--The option name for the UI
				uitype = K_COLORPICKER;				--The option type for the UI
				uilabel = PERL_CONF_BACK_COLOR;			--The label to use for the checkbox in the UI
				uidesc = PERL_CONF_BACK_COLOR_DESC;		--The description to use for the checkbox in the UI
				uidiff = 1;					--The difficulty of the option
				varcolor = "Perl_Config.BackColour";
				update = SetAllFrames;				--A command to perform when the option is succesfully updated
				textname = PERL_CONF_BACK_COLOR_DESC;
				uicolor = Perl_Config.BackColour;
				subcom = {"backcolor"};				--The sub slash command and any aliases for this option
				subhelp = PERL_CONF_BACK_COLOR_DESC;		--The help text for the sub slash command
			};
			--Register a color picker, and a color sub slash command for LowManaColor
			{
				uivar = "PerlBorderColour";			--The option name for the UI
				uitype = K_COLORPICKER;				--The option type for the UI
				uilabel = PERL_CONF_BORDER_COLOR;		--The label to use for the checkbox in the UI
				uidesc = PERL_CONF_BORDER_COLOR_DESC;		--The description to use for the checkbox in the UI
				uidiff = 1;					--The difficulty of the option
				varcolor = "Perl_Config.BorderColour";
				update = SetAllFrames;				--A command to perform when the option is succesfully updated
				textname = PERL_CONF_BORDER_COLOR_DESC;
				uicolor = Perl_Config.BorderColour;
				subcom = {"bordercolor"};			--The sub slash command and any aliases for this option
				subhelp = PERL_CONF_BORDER_COLOR_DESC;		--The help text for the sub slash command
			};

                        --Register a checkbox, and a boolean sub slash command for TargetCounters
			{
                                hasbool = true;                                 --Whether this options has a boolean part
                                uivar = "PerlFadingFrames";			--The option name for the UI
                                uitype = K_TEXT;                                --The option type for the UI
                                uilabel = PERL_CONF_FADING_FRAMES;		--The label to use for the checkbox in the UI
                                uidesc = PERL_CONF_FADING_FRAMES_DESC;		--The description to use for the checkbox in the UI
                                varbool = "Perl_Config.PerlFadeFrames";		--The boolean variable associate with this option
                                uicheck = Perl_Config.PerlFadeFrames;		--The default value for the checkbox in the UI
                                update = Perl_OptionActions;                    --A command to perform when the option is succesfully updated
                                subcom = {"fade"};				--The sub slash command and any aliases for this option
                                subhelp = PERL_CONF_FADING_FRAMES_DESC;		--The help text for the sub slash command
			};
                        --Register a checkbox, and a boolean sub slash command for TargetCounters
			{
                                hasbool = true;                                 --Whether this options has a boolean part
                                uivar = "PerlTargetCounters";                   --The option name for the UI
                                uitype = K_TEXT;                                --The option type for the UI
                                uilabel = PERL_CONF_TARGET_COUNTERS;            --The label to use for the checkbox in the UI
                                uidesc = PERL_CONF_TARGET_COUNTERS_DESC;        --The description to use for the checkbox in the UI
                                varbool = "Perl_Config.TargetCounters";		--The boolean variable associate with this option
                                uicheck = Perl_Config.TargetCounters;		--The default value for the checkbox in the UI
                                update = Perl_OptionActions;                    --A command to perform when the option is succesfully updated
                                subcom = {"counters"};				--The sub slash command and any aliases for this option
                                subhelp = PERL_CONF_TARGET_COUNTERS_DESC;       --The help text for the sub slash command
			};
                        --Register a checkbox, and a boolean sub slash command for TargetCounters Self Mode
			{
                                hasbool = true;                                 --Whether this options has a boolean part
                                uivar = "PerlTargetCountersSelf";		--The option name for the UI
                                uidep = { ["PerlTargetCounters"] = { checked = true } };
                                uitype = K_TEXT;                                --The option type for the UI
                                uilabel = PERL_CONF_TARGET_COUNTERSSELF;	--The label to use for the checkbox in the UI
                                uidesc = PERL_CONF_TARGET_COUNTERSSELF_DESC;	--The description to use for the checkbox in the UI
                                varbool = "Perl_Config.TargetCountersSelf";	--The boolean variable associate with this option
                                uicheck = Perl_Config.TargetCountersSelf;	--The default value for the checkbox in the UI
                                update = Perl_OptionActions;                    --A command to perform when the option is succesfully updated
                                subcom = {"counthealersonly"};			--The sub slash command and any aliases for this option
                                subhelp = PERL_CONF_TARGET_COUNTERSSELF_DESC;   --The help text for the sub slash command
			};
                        --Register a checkbox, and a boolean sub slash command for TargetCounters Enemy
			{
                                hasbool = true;                                 --Whether this options has a boolean part
                                uivar = "PerlTargetCountersEnemy";		--The option name for the UI
                                uidep = { ["PerlTargetCounters"] = { checked = true } };
                                uitype = K_TEXT;                                --The option type for the UI
                                uilabel = PERL_CONF_TARGET_COUNTERSENEMY;	--The label to use for the checkbox in the UI
                                uidesc = PERL_CONF_TARGET_COUNTERSENEMY_DESC;	--The description to use for the checkbox in the UI
                                varbool = "Perl_Config.TargetCountersEnemy";	--The boolean variable associate with this option
                                uicheck = Perl_Config.TargetCountersEnemy;	--The default value for the checkbox in the UI
                                update = Perl_OptionActions;                    --A command to perform when the option is succesfully updated
                                subcom = {"enemycounters"};			--The sub slash command and any aliases for this option
                                subhelp = PERL_CONF_TARGET_COUNTERSENEMY;   	--The help text for the sub slash command
			};
                        --Register a slider, and a number sub slash command for Player Frame Scale
			{
                                uivar = "PerlAssistsFrameScale";		--The option name for the UI
                                uitype = K_SLIDER;				--The option type for the UI
                                uilabel = PERL_CONF_ASSIST_SCALE;		--The label to use for the checkbox in the UI
                                uidesc = PERL_CONF_ASSIST_SCALE_DESC;		--The description to use for the checkbox in the UI
                                varnum = "Perl_Config.Scale_AssistsFrame";	--The number variable associate with this option
                                uislider = Perl_Config.Scale_AssistsFrame;	--The default value for the checkbox in the UI
                                textname = PERL_CONF_ASSIST_SCALE_CHANGED;	--What to say when the command is successfully updated, and there is no GUI
                                update = Perl_OptionActions;                    --A command to perform when the option is succesfully updated
				uimin = 0.5;
				uimax = 1.5;
                                uitext = "uitext";
				uistep = 0.01;
				uitexton = 1;
                                uisuffix = "%";
				uimul = 100;
                                subcom = {"setassistscale"};                    --The sub slash command and any aliases for this option
                                subhelp = PERL_CONF_ASSIST_SCALE_DESC;          --The help text for the sub slash command
			};

                        ----------------------------------------------------------------------------------------------------------
			{
                                uivar = "PerlSeparator2";                       --The option name for the UI
                                uitype = K_HEADER;                              --The option type for the UI
                                uidiff = 2;                                     --The difficulty of the option
                                uilabel = PERL_CONF_CAST_PARTY;                 --The label to use for the seperator in the UI
                                uidesc = PERL_CONF_CAST_PARTY_DESC;             --The description to use for the seperator in the UI
			};
                        --Register a checkbox, and a boolean sub slash command for CastParty Features
			{
                                hasbool = true;                                 --Whether this options has a boolean part
                                uivar = "PerlCastParty";                        --The option name for the UI
                                uitype = K_TEXT;                                --The option type for the UI
                                uilabel = PERL_CONF_CASTPARTY_FEATURES;         --The label to use for the checkbox in the UI
                                uidesc = PERL_CONF_CASTPARTY_FEATURES_DESC;     --The description to use for the checkbox in the UI
                                uidiff = 2;                                     --The difficulty of the option
                                varbool = "Perl_Config.CastParty";              --The boolean variable associate with this option
                                uicheck = Perl_Config.CastParty;                --The default value for the checkbox in the UI
                                update = Perl_OptionActions;                    --A command to perform when the option is succesfully updated
                                subcom = {"castparty"};                         --The sub slash command and any aliases for this option
                                subhelp = PERL_CONF_CASTPARTY_FEATURES_DESC;    --The help text for the sub slash command
			};
                        --Register a checkbox, and a boolean sub slash command for CastParty Frame
			{
                                hasbool = true;                                 --Whether this options has a boolean part
                                uivar = "PerlCastPartyFrame";                   --The option name for the UI
                                uitype = K_TEXT;                                --The option type for the UI
                                uilabel = PERL_CONF_CASTPARTY_FRAME;            --The label to use for the checkbox in the UI
                                uidesc = PERL_CONF_CASTPARTY_FRAME_DESC;        --The description to use for the checkbox in the UI
                                uidiff = 2;                                     --The difficulty of the option
                                uidep = { ["PerlCastParty"] = { checked = true } };
                                varbool = "Perl_Config.CastPartyShow";          --The boolean variable associate with this option
                                uicheck = Perl_Config.CastPartyShow;            --The default value for the checkbox in the UI
                                update = Perl_OptionActions;                    --A command to perform when the option is succesfully updated
                                subcom = {"castpartyframe"};                    --The sub slash command and any aliases for this option
                                subhelp = PERL_CONF_CASTPARTY_FRAME_DESC;       --The help text for the sub slash command
			};
                        ----------------------------------------------------------------------------------------------------------
			{
                                uivar = "PerlSeparator3";                       --The option name for the UI
                                uitype = K_HEADER;                              --The option type for the UI
                                uilabel = PERL_CONF_PLAYER;                     --The label to use for the seperator in the UI
                                uidesc = PERL_CONF_PLAYER_DESC;                 --The description to use for the seperator in the UI
			};
                        --Register a checkbox, and a boolean sub slash command for Player Portrait
			{
                                hasbool = true;                                 --Whether this options has a boolean part
                                uivar = "PerlPlayerPortrait";                   --The option name for the UI
                                uitype = K_TEXT;                                --The option type for the UI
                                uilabel = PERL_CONF_PLAYER_PORTRAIT;            --The label to use for the checkbox in the UI
                                uidesc = PERL_CONF_PLAYER_PORTRAIT_DESC;        --The description to use for the checkbox in the UI
                                varbool = "Perl_Config.ShowPlayerPortrait";     --The boolean variable associate with this option
                                uicheck = Perl_Config.ShowPlayerPortrait;       --The default value for the checkbox in the UI
                                update = Perl_OptionActions;                    --A command to perform when the option is succesfully updated
                                subcom = {"playerportrait", "pp"};              --The sub slash command and any aliases for this option
                                subhelp = PERL_CONF_PLAYER_PORTRAIT_DESC;       --The help text for the sub slash command
			};
                        --Register a checkbox, and a boolean sub slash command for Player Level
			{
                                hasbool = true;                                 --Whether this options has a boolean part
                                uivar = "PerlPlayerLevel";                      --The option name for the UI
                                uitype = K_TEXT;                                --The option type for the UI
                                uilabel = PERL_CONF_PLAYER_LEVEL;               --The label to use for the checkbox in the UI
                                uidesc = PERL_CONF_PLAYER_LEVEL_DESC;           --The description to use for the checkbox in the UI
                                varbool = "Perl_Config.ShowPlayerLevel";        --The boolean variable associate with this option
                                uicheck = Perl_Config.ShowPlayerLevel;          --The default value for the checkbox in the UI
                                update = Perl_OptionActions;                    --A command to perform when the option is succesfully updated
                                subcom = {"playerlevel"};                       --The sub slash command and any aliases for this option
                                subhelp = PERL_CONF_PLAYER_LEVEL_DESC;          --The help text for the sub slash command
			};
                        --Register a checkbox, and a boolean sub slash command for Player Class Icon
			{
                                hasbool = true;                                 --Whether this options has a boolean part
                                uivar = "PerlPlayerClassIcon";                  --The option name for the UI
                                uitype = K_TEXT;                                --The option type for the UI
                                uilabel = PERL_CONF_PLAYER_ICON;                --The label to use for the checkbox in the UI
                                uidesc = PERL_CONF_PLAYER_ICON_DESC;            --The description to use for the checkbox in the UI
                                varbool = "Perl_Config.ShowPlayerClassIcon";    --The boolean variable associate with this option
                                uicheck = Perl_Config.ShowPlayerClassIcon;      --The default value for the checkbox in the UI
                                update = Perl_OptionActions;                    --A command to perform when the option is succesfully updated
                                subcom = {"playerclass", "pc"};                 --The sub slash command and any aliases for this option
                                subhelp = PERL_CONF_PLAYER_ICON_DESC;           --The help text for the sub slash command
			};
                        --Register a checkbox, and a boolean sub slash command for Player XP Bar
			{
                                hasbool = true;                                 --Whether this options has a boolean part
                                uivar = "PerlPlayerXPBar";                      --The option name for the UI
                                uitype = K_TEXT;                                --The option type for the UI
                                uilabel = PERL_CONF_PLAYER_XP;                  --The label to use for the checkbox in the UI
                                uidesc = PERL_CONF_PLAYER_XP_DESC;              --The description to use for the checkbox in the UI
                                varbool = "Perl_Config.ShowPlayerXPBar";        --The boolean variable associate with this option
                                uicheck = Perl_Config.ShowPlayerXPBar;          --The default value for the checkbox in the UI
                                update = Perl_OptionActions;                    --A command to perform when the option is succesfully updated
                                subcom = {"playerxp", "pxp"};                   --The sub slash command and any aliases for this option
                                subhelp = PERL_CONF_PLAYER_XP_DESC;             --The help text for the sub slash command
			};
                        --Register a checkbox, and a boolean sub slash command for Player Class Rank
			{
                                hasbool = true;                                 --Whether this options has a boolean part
                                uivar = "PerlPlayerPVPRank";                    --The option name for the UI
                                uitype = K_TEXT;                                --The option type for the UI
                                uilabel = PERL_CONF_PLAYER_PVP;                 --The label to use for the checkbox in the UI
                                uidesc = PERL_CONF_PLAYER_PVP_DESC;             --The description to use for the checkbox in the UI
                                varbool = "Perl_Config.ShowPlayerPVPRank";      --The boolean variable associate with this option
                                uicheck = Perl_Config.ShowPlayerPVPRank;        --The default value for the checkbox in the UI
                                update = Perl_OptionActions;                    --A command to perform when the option is succesfully updated
                                subcom = {"playerrank"};                        --The sub slash command and any aliases for this option
                                subhelp = PERL_CONF_PLAYER_PVP_DESC;            --The help text for the sub slash command
			};
                        --Register a checkbox, and a boolean sub slash command for Old Player Frame
			{
                                hasbool = true;                                 --Whether this options has a boolean part
                                uivar = "PerlOldPlayerFrame";                   --The option name for the UI
                                uitype = K_TEXT;                                --The option type for the UI
                                uilabel = PERL_CONF_PLAYER_OLDFRAME;            --The label to use for the checkbox in the UI
                                uidesc = PERL_CONF_PLAYER_OLDFRAME_DESC;        --The description to use for the checkbox in the UI
                                uidiff = 2;                                     --The difficulty of the option
                                varbool = "Perl_Config.ShowOldPlayerFrame";     --The boolean variable associate with this option
                                uicheck = Perl_Config.ShowOldPlayerFrame;       --The default value for the checkbox in the UI
                                update = Perl_OptionActions;                    --A command to perform when the option is succesfully updated
                                subcom = {"blizzardplayer", "old"};             --The sub slash command and any aliases for this option
                                subhelp = PERL_CONF_PLAYER_OLDFRAME_DESC;       --The help text for the sub slash command
			};
                        --Register a slider, and a number sub slash command for Player Frame Scale
			{
                                uivar = "PerlPlayerFrameScale";                 --The option name for the UI
                                uitype = K_SLIDER;                              --The option type for the UI
                                uilabel = PERL_CONF_PLAYER_SCALE;               --The label to use for the checkbox in the UI
                                uidesc = PERL_CONF_PLAYER_SCALE_DESC;           --The description to use for the checkbox in the UI
                                varnum = "Perl_Config.Scale_PlayerFrame";       --The number variable associate with this option
                                uislider = Perl_Config.Scale_PlayerFrame;       --The default value for the checkbox in the UI
                                textname = PERL_CONF_PLAYER_SCALE_CHANGED;      --What to say when the command is successfully updated, and there is no GUI
                                update = Perl_OptionActions;                    --A command to perform when the option is succesfully updated
				uimin = 0.5;
				uimax = 1.5;
                                uitext = "uitext";
				uistep = 0.01;
				uitexton = 1;
                                uisuffix = "%";
				uimul = 100;
                                subcom = {"setplayerscale"};                    --The sub slash command and any aliases for this option
                                subhelp = PERL_CONF_PLAYER_SCALE_DESC;          --The help text for the sub slash command
			};
                        --Register a slider, and a number sub slash command for Pet Frame Scale
			{
                                uivar = "PerlPetFrameScale";                    --The option name for the UI
                                uitype = K_SLIDER;                              --The option type for the UI
                                uilabel = PERL_CONF_PLAYER_PET_SCALE;           --The label to use for the checkbox in the UI
                                uidesc = PERL_CONF_PLAYER_PET_SCALE_DESC;       --The description to use for the checkbox in the UI
                                varnum = "Perl_Config.Scale_PetFrame";          --The number variable associate with this option
                                uislider = Perl_Config.Scale_PetFrame;          --The default value for the checkbox in the UI
                                textname = PERL_CONF_PLAYER_PET_SCALE_CHANGED;  --What to say when the command is successfully updated, and there is no GUI
                                update = Perl_OptionActions;                    --A command to perform when the option is succesfully updated
				uimin = 0.5;
				uimax = 1.5;
                                uitext = "uitext";
				uistep = 0.01;
				uitexton = 1;
                                uisuffix = "%";
				uimul = 100;
                                subcom = {"setpetscale", "petfs"};              --The sub slash command and any aliases for this option
                                subhelp = PERL_CONF_PLAYER_PET_SCALE_DESC;      --The help text for the sub slash command
			};
                        --Register a checkbox, and a boolean sub slash command for Pet Level
			{
                                hasbool = true;                                 --Whether this options has a boolean part
                                uivar = "PerlPetLevel";                         --The option name for the UI
                                uitype = K_TEXT;                                --The option type for the UI
                                uilabel = PERL_CONF_PLAYER_PET_LEVEL;           --The label to use for the checkbox in the UI
                                uidesc = PERL_CONF_PLAYER_PET_LEVEL_DESC;       --The description to use for the checkbox in the UI
                                varbool = "Perl_Config.ShowPetLevel";           --The boolean variable associate with this option
                                uicheck = Perl_Config.ShowPetLevel;             --The default value for the checkbox in the UI
                                update = Perl_OptionActions;                    --A command to perform when the option is succesfully updated
                                subcom = {"petlevel"};                          --The sub slash command and any aliases for this option
                                subhelp = PERL_CONF_PLAYER_PET_LEVEL_DESC;      --The help text for the sub slash command
			};
                        --Register a checkbox, and a boolean sub slash command for Pet Happiness
			{
                                hasbool = true;                                 --Whether this options has a boolean part
                                uivar = "PerlPetHappiness";                     --The option name for the UI
                                uitype = K_TEXT;                                --The option type for the UI
                                uilabel = PERL_CONF_PLAYER_PET_HAPPINESS;       --The label to use for the checkbox in the UI
                                uidesc = PERL_CONF_PLAYER_PET_HAPPINESS_DESC;   --The description to use for the checkbox in the UI
                                varbool = "Perl_Config.PetHappiness";           --The boolean variable associate with this option
                                uicheck = Perl_Config.PetHappiness;             --The default value for the checkbox in the UI
                                update = Perl_OptionActions;                    --A command to perform when the option is succesfully updated
                                subcom = {"pethappiness", "peth"};              --The sub slash command and any aliases for this option
                                subhelp = PERL_CONF_PLAYER_PET_HAPPINESS_DESC;  --The help text for the sub slash command
			};
                        --Register a checkbox, and a boolean sub slash command for Pet XP
			{
                                hasbool = true;                                 --Whether this options has a boolean part
                                uivar = "PerlPetXP";                            --The option name for the UI
                                uitype = K_TEXT;                                --The option type for the UI
                                uilabel = PERL_CONF_PLAYER_PET_XP;              --The label to use for the checkbox in the UI
                                uidesc = PERL_CONF_PLAYER_PET_XP_DESC;          --The description to use for the checkbox in the UI
                                varbool = "Perl_Config.ShowPetXP";              --The boolean variable associate with this option
                                uicheck = Perl_Config.ShowPetXP;                --The default value for the checkbox in the UI
                                update = Perl_OptionActions;                    --A command to perform when the option is succesfully updated
                                subcom = {"petxp"};                             --The sub slash command and any aliases for this option
                                subhelp = PERL_CONF_PLAYER_PET_XP_DESC;         --The help text for the sub slash command
			};
                        --Register a checkbox, and a boolean sub slash command for Pet XP
			{
                                hasbool = true;                                 --Whether this options has a boolean part
                                uivar = "PerlPartyNumber";			--The option name for the UI
                                uitype = K_TEXT;                                --The option type for the UI
                                uilabel = PERL_CONF_PLAYER_PARTY_NUM;		--The label to use for the checkbox in the UI
                                uidesc = PERL_CONF_PLAYER_PARTY_NUM_DESC;	--The description to use for the checkbox in the UI
                                varbool = "Perl_Config.ShowPartyNumber";	--The boolean variable associate with this option
                                uicheck = Perl_Config.ShowPartyNumber;          --The default value for the checkbox in the UI
                                update = Perl_OptionActions;                    --A command to perform when the option is succesfully updated
                                subcom = {"partynumber"};			--The sub slash command and any aliases for this option
                                subhelp = PERL_CONF_PLAYER_PARTY_NUM_DESC;	--The help text for the sub slash command
			};

                        ----------------------------------------------------------------------------------------------------------
			{
                                uivar = "PerlSeparator4";                       --The option name for the UI
                                uitype = K_HEADER;                              --The option type for the UI
                                uilabel = PERL_CONF_TARGET;                     --The label to use for the seperator in the UI
                                uidesc = PERL_CONF_TARGET_DESC;                 --The description to use for the seperator in the UI
			};
                        --Register a checkbox, and a boolean sub slash command for Target Portrait
			{
                                hasbool = true;                                 --Whether this options has a boolean part
                                uivar = "PerlTargetPortrait";                   --The option name for the UI
                                uitype = K_TEXT;                                --The option type for the UI
                                uilabel = PERL_CONF_TARGET_PORTRAIT;            --The label to use for the checkbox in the UI
                                uidesc = PERL_CONF_TARGET_PORTRAIT_DESC;        --The description to use for the checkbox in the UI
                                varbool = "Perl_Config.ShowTargetPortrait";     --The boolean variable associate with this option
                                uicheck = Perl_Config.ShowTargetPortrait;       --The default value for the checkbox in the UI
                                update = Perl_OptionActions;                    --A command to perform when the option is succesfully updated
                                subcom = {"targetportrait", "tp"};              --The sub slash command and any aliases for this option
                                subhelp = PERL_CONF_TARGET_PORTRAIT_DESC;       --The help text for the sub slash command
			};
                        --Register a checkbox, and a boolean sub slash command for Target Class Icon
			{
                                hasbool = true;                                 --Whether this options has a boolean part
                                uivar = "PerlTargetClassIcon";                  --The option name for the UI
                                uitype = K_TEXT;                                --The option type for the UI
                                uilabel = PERL_CONF_TARGET_ICON;                --The label to use for the checkbox in the UI
                                uidesc = PERL_CONF_TARGET_ICON_DESC;            --The description to use for the checkbox in the UI
                                varbool = "Perl_Config.ShowTargetClassIcon";    --The boolean variable associate with this option
                                uicheck = Perl_Config.ShowTargetClassIcon;      --The default value for the checkbox in the UI
                                update = Perl_OptionActions;                    --A command to perform when the option is succesfully updated
                                subcom = {"targetclass", "tci"};                --The sub slash command and any aliases for this option
                                subhelp = PERL_CONF_TARGET_ICON_DESC;           --The help text for the sub slash command
			};
                        --Register a checkbox, and a boolean sub slash command for Target Level
			{
                                hasbool = true;                                 --Whether this options has a boolean part
                                uivar = "PerlTargetLevel";                      --The option name for the UI
                                uitype = K_TEXT;                                --The option type for the UI
                                uilabel = PERL_CONF_TARGET_LEVEL;               --The label to use for the checkbox in the UI
                                uidesc = PERL_CONF_TARGET_LEVEL_DESC;           --The description to use for the checkbox in the UI
                                varbool = "Perl_Config.ShowTargetLevel";        --The boolean variable associate with this option
                                uicheck = Perl_Config.ShowTargetLevel;          --The default value for the checkbox in the UI
                                update = Perl_OptionActions;                    --A command to perform when the option is succesfully updated
                                subcom = {"targetlevel"};                       --The sub slash command and any aliases for this option
                                subhelp = PERL_CONF_TARGET_LEVEL_DESC;          --The help text for the sub slash command
			};
                        --Register a checkbox, and a boolean sub slash command for Target Class Rank
			{
                                hasbool = true;                                 --Whether this options has a boolean part
                                uivar = "PerlTargetPVPRank";                    --The option name for the UI
                                uitype = K_TEXT;                                --The option type for the UI
                                uilabel = PERL_CONF_TARGET_PVP;                 --The label to use for the checkbox in the UI
                                uidesc = PERL_CONF_TARGET_PVP_DESC;             --The description to use for the checkbox in the UI
                                varbool = "Perl_Config.ShowTargetPVPRank";      --The boolean variable associate with this option
                                uicheck = Perl_Config.ShowTargetPVPRank;        --The default value for the checkbox in the UI
                                update = Perl_OptionActions;                    --A command to perform when the option is succesfully updated
                                subcom = {"targetrank"};                        --The sub slash command and any aliases for this option
                                subhelp = PERL_CONF_TARGET_PVP_DESC;            --The help text for the sub slash command
			};
                        --Register a checkbox, and a boolean sub slash command for Target Mob Type
			{
                                hasbool = true;                                 --Whether this options has a boolean part
                                uivar = "PerlTargetMobType";                    --The option name for the UI
                                uitype = K_TEXT;                                --The option type for the UI
                                uilabel = PERL_CONF_TARGET_MOBTYPE;             --The label to use for the checkbox in the UI
                                uidesc = PERL_CONF_TARGET_MOBTYPE_DESC;         --The description to use for the checkbox in the UI
                                varbool = "Perl_Config.ShowTargetMobType";      --The boolean variable associate with this option
                                uicheck = Perl_Config.ShowTargetMobType;        --The default value for the checkbox in the UI
                                update = Perl_OptionActions;                    --A command to perform when the option is succesfully updated
                                subcom = {"targetmobtype", "mobt"};             --The sub slash command and any aliases for this option
                                subhelp = PERL_CONF_TARGET_MOBTYPE_DESC;        --The help text for the sub slash command
			};
                        --Register a checkbox, and a boolean sub slash command for Target Mob Type
			{
                                hasbool = true;                                 --Whether this options has a boolean part
                                uivar = "PerlTargetElite";                      --The option name for the UI
                                uitype = K_TEXT;                                --The option type for the UI
                                uilabel = PERL_CONF_TARGET_ELITE;               --The label to use for the checkbox in the UI
                                uidesc = PERL_CONF_TARGET_ELITE_DESC;           --The description to use for the checkbox in the UI
                                varbool = "Perl_Config.ShowTargetElite";        --The boolean variable associate with this option
                                uicheck = Perl_Config.ShowTargetElite;          --The default value for the checkbox in the UI
                                update = Perl_OptionActions;                    --A command to perform when the option is succesfully updated
                                subcom = {"targetelite"};                       --The sub slash command and any aliases for this option
                                subhelp = PERL_CONF_TARGET_ELITE_DESC;          --The help text for the sub slash command
			};
                        --Register a checkbox, and a boolean sub slash command for Target Mana
			{
                                hasbool = true;                                 --Whether this options has a boolean part
                                uivar = "PerlTargetMana";                       --The option name for the UI
                                uitype = K_TEXT;                                --The option type for the UI
                                uilabel = PERL_CONF_TARGET_MANA;                --The label to use for the checkbox in the UI
                                uidesc = PERL_CONF_TARGET_MANA_DESC;            --The description to use for the checkbox in the UI
                                varbool = "Perl_Config.ShowTargetMana";         --The boolean variable associate with this option
                                uicheck = Perl_Config.ShowTargetMana;           --The default value for the checkbox in the UI
                                update = Perl_OptionActions;                    --A command to perform when the option is succesfully updated
                                subcom = {"targetmana", "tmana"};               --The sub slash command and any aliases for this option
                                subhelp = PERL_CONF_TARGET_MANA_DESC;           --The help text for the sub slash command
			};
                        --Register a checkbox, and a boolean sub slash command for Target CP Meter
			{
                                hasbool = true;                                 --Whether this options has a boolean part
                                uivar = "PerlTargetCP";                         --The option name for the UI
                                uitype = K_TEXT;                                --The option type for the UI
                                uilabel = PERL_CONF_TARGET_CP;                  --The label to use for the checkbox in the UI
                                uidesc = PERL_CONF_TARGET_CP_DESC;              --The description to use for the checkbox in the UI
                                varbool = "Perl_Config.UseCPMeter";             --The boolean variable associate with this option
                                uicheck = Perl_Config.UseCPMeter;               --The default value for the checkbox in the UI
                                update = Perl_OptionActions;                    --A command to perform when the option is succesfully updated
                                subcom = {"usecpmeter"};                        --The sub slash command and any aliases for this option
                                subhelp = PERL_CONF_TARGET_CP_DESC;             --The help text for the sub slash command
			};
                        --Register a slider, and a number sub slash command for Target Frame Scale
			{
                                uivar = "PerlTargetFrameScale";                 --The option name for the UI
                                uitype = K_SLIDER;                              --The option type for the UI
                                uilabel = PERL_CONF_TARGET_SCALE;               --The label to use for the checkbox in the UI
                                uidesc = PERL_CONF_TARGET_SCALE_DESC;           --The description to use for the checkbox in the UI
                                uidiff = 3;                                     --The difficulty of the option
                                varnum = "Perl_Config.Scale_TargetFrame";       --The number variable associate with this option
                                uislider = Perl_Config.Scale_TargetFrame;       --The default value for the checkbox in the UI
                                textname = PERL_CONF_TARGET_SCALE_CHANGED;      --What to say when the command is successfully updated, and there is no GUI
                                update = Perl_OptionActions;                    --A command to perform when the option is succesfully updated
				uimin = 0.5;
				uimax = 1.5;
                                uitext = "uitext";
				uistep = 0.01;
				uitexton = 1;
                                uisuffix = "%";
				uimul = 100;
                                subcom = {"settargetscale", "tfs"};             --The sub slash command and any aliases for this option
                                subhelp = PERL_CONF_TARGET_SCALE_DESC;          --The help text for the sub slash command
			};
                        --Register a slider, and a number sub slash command for Target Target Frame Scale
			{
                                uivar = "PerlTargetTargetFrameScale";           --The option name for the UI
                                uitype = K_SLIDER;                              --The option type for the UI
                                uilabel = PERL_CONF_TARGETTARGET_SCALE;         --The label to use for the checkbox in the UI
                                uidesc = PERL_CONF_TARGETTARGET_SCALE_DESC;     --The description to use for the checkbox in the UI
                                uidiff = 3;                                     --The difficulty of the option
                                varnum = "Perl_Config.Scale_TargetTargetFrame"; --The number variable associate with this option
                                uislider = Perl_Config.Scale_TargetTargetFrame; --The default value for the checkbox in the UI
                                textname = PERL_CONF_TARGETTARGET_SCALE_CHANGED; --What to say when the command is successfully updated, and there is no GUI
                                update = Perl_OptionActions;                    --A command to perform when the option is succesfully updated
				uimin = 0.5;
				uimax = 1.5;
                                uitext = "uitext";
				uistep = 0.01;
				uitexton = 1;
                                uisuffix = "%";
				uimul = 100;
                                subcom = {"settargettargetscale"};              --The sub slash command and any aliases for this option
                                subhelp = PERL_CONF_TARGETTARGET_SCALE_DESC;    --The help text for the sub slash command
			};
                        ----------------------------------------------------------------------------------------------------------
			{
                                uivar = "PerlSeparator5";                       --The option name for the UI
                                uitype = K_HEADER;                              --The option type for the UI
                                uidiff = 2;                                     --The difficulty of the option
                                uilabel = PERL_CONF_PARTY;                      --The label to use for the seperator in the UI
                                uidesc = PERL_CONF_PARTY_DESC;                  --The description to use for the seperator in the UI
			};
                        --Register a checkbox, and a boolean sub slash command for Party Names
			{
                                hasbool = true;                                 --Whether this options has a boolean part
                                uivar = "PerlPartyNames";                       --The option name for the UI
                                uitype = K_TEXT;                                --The option type for the UI
                                uilabel = PERL_CONF_PARTY_NAMES;                --The label to use for the checkbox in the UI
                                uidesc = PERL_CONF_PARTY_NAMES_DESC;            --The description to use for the checkbox in the UI
                                varbool = "Perl_Config.ShowPartyNames";         --The boolean variable associate with this option
                                uicheck = Perl_Config.ShowPartyNames;           --The default value for the checkbox in the UI
                                update = Perl_OptionActions;                    --A command to perform when the option is succesfully updated
                                subcom = {"partynames"};                        --The sub slash command and any aliases for this option
                                subhelp = PERL_CONF_PARTY_NAMES_DESC;           --The help text for the sub slash command
			};
                        --Register a checkbox, and a boolean sub slash command for Party Level
			{
                                hasbool = true;                                 --Whether this options has a boolean part
                                uivar = "PerlPartyLevel";                       --The option name for the UI
                                uitype = K_TEXT;                                --The option type for the UI
                                uilabel = PERL_CONF_PARTY_LEVEL;                --The label to use for the checkbox in the UI
                                uidesc = PERL_CONF_PARTY_LEVEL_DESC;            --The description to use for the checkbox in the UI
                                varbool = "Perl_Config.ShowPartyLevel";         --The boolean variable associate with this option
                                uicheck = Perl_Config.ShowPartyLevel;           --The default value for the checkbox in the UI
                                update = Perl_OptionActions;                    --A command to perform when the option is succesfully updated
                                subcom = {"partylevel"};                        --The sub slash command and any aliases for this option
                                subhelp = PERL_CONF_PARTY_LEVEL_DESC;           --The help text for the sub slash command
			};
                        --Register a checkbox, and a boolean sub slash command for Party Class Icon
			{
                                hasbool = true;                                 --Whether this options has a boolean part
                                uivar = "PerlPartyClassIcon";                   --The option name for the UI
                                uitype = K_TEXT;                                --The option type for the UI
                                uilabel = PERL_CONF_PARTY_ICON;                 --The label to use for the checkbox in the UI
                                uidesc = PERL_CONF_PARTY_ICON_DESC;             --The description to use for the checkbox in the UI
                                varbool = "Perl_Config.ShowPartyClassIcon";     --The boolean variable associate with this option
                                uicheck = Perl_Config.ShowPartyClassIcon;       --The default value for the checkbox in the UI
                                update = Perl_OptionActions;                    --A command to perform when the option is succesfully updated
                                subcom = {"partyicon"};                         --The sub slash command and any aliases for this option
                                subhelp = PERL_CONF_PARTY_ICON_DESC;            --The help text for the sub slash command
			};
                        --Register a checkbox, and a boolean sub slash command for Party In Raid
			{
                                hasbool = true;                                 --Whether this options has a boolean part
                                uivar = "PerlPartyInRaid";                      --The option name for the UI
                                uitype = K_TEXT;                                --The option type for the UI
                                uilabel = PERL_CONF_PARTY_INRAID;               --The label to use for the checkbox in the UI
                                uidesc = PERL_CONF_PARTY_INRAID_DESC;           --The description to use for the checkbox in the UI
                                varbool = "Perl_Config.ShowPartyRaid";          --The boolean variable associate with this option
                                uicheck = Perl_Config.ShowPartyRaid;            --The default value for the checkbox in the UI
                                update = Perl_OptionActions;                    --A command to perform when the option is succesfully updated
                                subcom = {"partyinraid"};                       --The sub slash command and any aliases for this option
                                subhelp = PERL_CONF_PARTY_INRAID_DESC;          --The help text for the sub slash command
			};
                        --Register a checkbox, and a boolean sub slash command for Party Percentages
			{
                                hasbool = true;                                 --Whether this options has a boolean part
                                uivar = "PerlPartyPercentages";                 --The option name for the UI
                                uitype = K_TEXT;                                --The option type for the UI
                                uilabel = PERL_CONF_PARTY_PERC;                 --The label to use for the checkbox in the UI
                                uidesc = PERL_CONF_PARTY_PERC_DESC;             --The description to use for the checkbox in the UI
                                varbool = "Perl_Config.ShowPartyPercent";       --The boolean variable associate with this option
                                uicheck = Perl_Config.ShowPartyPercent;         --The default value for the checkbox in the UI
                                update = Perl_OptionActions;                    --A command to perform when the option is succesfully updated
                                subcom = {"partypercent"};                      --The sub slash command and any aliases for this option
                                subhelp = PERL_CONF_PARTY_PERC_DESC;            --The help text for the sub slash command
			};
                        --Register a slider, and a number sub slash command for Party Frame Scale
			{
                                uivar = "PerlPartyFrameScale";                  --The option name for the UI
                                uitype = K_SLIDER;                              --The option type for the UI
                                uilabel = PERL_CONF_PARTY_SCALE;                --The label to use for the checkbox in the UI
                                uidesc = PERL_CONF_PARTY_SCALE_DESC;            --The description to use for the checkbox in the UI
                                varnum = "Perl_Config.Scale_PartyFrame";        --The number variable associate with this option
                                uislider = Perl_Config.Scale_PartyFrame;        --The default value for the checkbox in the UI
                                textname = PERL_CONF_PARTY_SCALE_CHANGED;       --What to say when the command is successfully updated, and there is no GUI
                                update = Perl_OptionActions;                    --A command to perform when the option is succesfully updated
				uimin = 0.5;
				uimax = 1.5;
                                uitext = "uitext";
				uistep = 0.01;
				uitexton = 1;
                                uisuffix = "%";
				uimul = 100;
                                subcom = {"setpartyscale"};                     --The sub slash command and any aliases for this option
                                subhelp = PERL_CONF_PARTY_SCALE_DESC;           --The help text for the sub slash command
			};
                        --Register a checkbox, and a boolean sub slash command for Party Pets
			{
                                hasbool = true;                                 --Whether this options has a boolean part
                                uivar = "PerlPartyPets";                        --The option name for the UI
                                uitype = K_TEXT;                                --The option type for the UI
                                uilabel = PERL_CONF_PARTY_PETS;                 --The label to use for the checkbox in the UI
                                uidesc = PERL_CONF_PARTY_PETS_DESC;             --The description to use for the checkbox in the UI
                                varbool = "Perl_Config.ShowPartyPets";          --The boolean variable associate with this option
                                uicheck = Perl_Config.ShowPartyPets;            --The default value for the checkbox in the UI
                                update = Perl_OptionActions;                    --A command to perform when the option is succesfully updated
                                subcom = {"partypets"};                         --The sub slash command and any aliases for this option
                                subhelp = PERL_CONF_PARTY_PETS_DESC;            --The help text for the sub slash command
			};
                        --Register a checkbox, and a boolean sub slash command for Party Targets
			{
                                hasbool = true;                                 --Whether this options has a boolean part
                                uivar = "PerlPartyTarget";                      --The option name for the UI
                                uitype = K_TEXT;                                --The option type for the UI
                                uilabel = PERL_CONF_PARTY_TARGET;       	--The label to use for the checkbox in the UI
                                uidesc = PERL_CONF_PARTY_TARGET_DESC;  		--The description to use for the checkbox in the UI
                                varbool = "Perl_Config.ShowPartyTarget";	--The boolean variable associate with this option
                                uicheck = Perl_Config.ShowPartyTarget;		--The default value for the checkbox in the UI
                                update = Perl_OptionActions;                    --A command to perform when the option is succesfully updated
				subcom = {"partytarget"};			--The sub slash command and any aliases for this option
                                subhelp = PERL_CONF_PARTY_TARGET;		--The help text for the sub slash command
			};
                        --Register a checkbox, and a boolean sub slash command for Party Debuffs Below
			{
                                hasbool = true;                                 --Whether this options has a boolean part
                                uivar = "PerlPartyDebuffs";                     --The option name for the UI
                                uitype = K_TEXT;                                --The option type for the UI
                                uilabel = PERL_CONF_PARTY_DEBUFFSBELOW;         --The label to use for the checkbox in the UI
                                uidesc = PERL_CONF_PARTY_DEBUFFSBELOW_DESC;     --The description to use for the checkbox in the UI
                                varbool = "Perl_Config.PartyDebuffsBelow";      --The boolean variable associate with this option
                                uicheck = Perl_Config.PartyDebuffsBelow;        --The default value for the checkbox in the UI
                                update = Perl_OptionActions;                    --A command to perform when the option is succesfully updated
                                subcom = {"debuffs"};                           --The sub slash command and any aliases for this option
                                subhelp = PERL_CONF_PARTY_DEBUFFSBELOW_DESC;    --The help text for the sub slash command
			};
--[[
                        ----------------------------------------------------------------------------------------------------------
			{
                                uivar = "PerlSeparator6";                       --The option name for the UI
                                uitype = K_HEADER;                              --The option type for the UI
                                uidiff = 2;                                     --The difficulty of the option
                                uilabel = PERL_CONF_RAID;                       --The label to use for the seperator in the UI
                                uidesc = PERL_CONF_RAID_DESC;                   --The description to use for the seperator in the UI
			};
                        --Register a checkbox, and a boolean sub slash command for Raid Frames
			{
                                hasbool = true;                                 --Whether this options has a boolean part
                                uivar = "PerlRaidFrames";                       --The option name for the UI
                                uitype = K_TEXT;                                --The option type for the UI
                                uilabel = PERL_CONF_RAID_SHOW;                  --The label to use for the checkbox in the UI
                                uidesc = PERL_CONF_RAID_SHOW_DESC;              --The description to use for the checkbox in the UI
                                uidiff = 2;                                     --The difficulty of the option
                                varbool = "Perl_Config.ShowRaid";               --The boolean variable associate with this option
                                uicheck = Perl_Config.ShowRaid;                 --The default value for the checkbox in the UI
                                update = Perl_OptionActions;                    --A command to perform when the option is succesfully updated
                                subcom = {"raidframes", "rf"};                  --The sub slash command and any aliases for this option
                                subhelp = PERL_CONF_RAID_SHOW_DESC;             --The help text for the sub slash command
			};
                        --Register a slider, and a number sub slash command for Raid Frame Scale
			{
                                uivar = "PerlRaidFrameScale";                   --The option name for the UI
                                uidep = { ["PerlRaidFrames"] = { checked = true } };
                                uitype = K_SLIDER;                              --The option type for the UI
                                uilabel = PERL_CONF_RAID_SCALE;                 --The label to use for the checkbox in the UI
                                uidesc = PERL_CONF_RAID_SCALE_DESC;             --The description to use for the checkbox in the UI
                                uidiff = 2;                                     --The difficulty of the option
                                varnum = "Perl_Config.Scale_RaidFrame";         --The number variable associate with this option
                                uislider = Perl_Config.Scale_RaidFrame;         --The default value for the checkbox in the UI
                                textname = PERL_CONF_RAID_SCALE_CHANGED;        --What to say when the command is successfully updated, and there is no GUI
                                update = Perl_OptionActions;                    --A command to perform when the option is succesfully updated
				uimin = 0.5;
				uimax = 1.5;
                                uitext = "uitext";
				uistep = 0.01;
				uitexton = 1;
                                uisuffix = "%";
				uimul = 100;
                                subcom = {"raidscale"};                         --The sub slash command and any aliases for this option
                                subhelp = PERL_CONF_RAID_SCALE_DESC;            --The help text for the sub slash command
			};
                        --Register a checkbox, and a boolean sub slash command for Sort By Class
			{
                                hasbool = true;                                 --Whether this options has a boolean part
                                uivar = "PerlRaidSortByClass";                  --The option name for the UI
                                uidep = { ["PerlRaidFrames"] = { checked = true } };
                                uitype = K_TEXT;                                --The option type for the UI
                                uilabel = PERL_CONF_RAID_SORTBYCLASS;           --The label to use for the checkbox in the UI
                                uidesc = PERL_CONF_RAID_SORTBYCLASS_DESC;       --The description to use for the checkbox in the UI
                                uidiff = 2;                                     --The difficulty of the option
                                varbool = "Perl_Config.SortRaidByClass";        --The boolean variable associate with this option
                                uicheck = Perl_Config.SortRaidByClass;          --The default value for the checkbox in the UI
                                update = Perl_OptionActions;                    --A command to perform when the option is succesfully updated
                                subcom = {"sortbyclass"};                       --The sub slash command and any aliases for this option
                                subhelp = PERL_CONF_RAID_SORTBYCLASS_DESC;      --The help text for the sub slash command
			};
                        --Register a checkbox, and a boolean sub slash command for Raid Percentages
			{
                                hasbool = true;                                 --Whether this options has a boolean part
                                uivar = "PerlRaidPercentages";                  --The option name for the UI
                                uidep = { ["PerlRaidFrames"] = { checked = true } };
                                uitype = K_TEXT;                                --The option type for the UI
                                uilabel = PERL_CONF_RAID_PERC;                  --The label to use for the checkbox in the UI
                                uidesc = PERL_CONF_RAID_PERC_DESC;              --The description to use for the checkbox in the UI
                                uidiff = 2;                                     --The difficulty of the option
                                varbool = "Perl_Config.ShowRaidPercent";        --The boolean variable associate with this option
                                uicheck = Perl_Config.ShowRaidPercent;          --The default value for the checkbox in the UI
                                update = Perl_OptionActions;                    --A command to perform when the option is succesfully updated
                                subcom = {"raidperc"};                          --The sub slash command and any aliases for this option
                                subhelp = PERL_CONF_RAID_PERC_DESC;             --The help text for the sub slash command
			};
                        --Register a checkbox, and a boolean sub slash command for Group 1
			{
                                hasbool = true;                                 --Whether this options has a boolean part
                                uivar = "PerlRaidGroup1";                       --The option name for the UI
                                uidep = { ["PerlRaidFrames"] = { checked = true } };
                                uitype = K_TEXT;                                --The option type for the UI
                                uilabel = PERL_CONF_RAID_GROUP1;                --The label to use for the checkbox in the UI
                                uidesc = PERL_CONF_RAID_GROUP1_DESC;            --The description to use for the checkbox in the UI
                                uidiff = 2;                                     --The difficulty of the option
                                varbool = "Perl_Config.ShowGroup1";             --The boolean variable associate with this option
                                uicheck = Perl_Config.ShowGroup1;               --The default value for the checkbox in the UI
                                update = Perl_OptionActions;                    --A command to perform when the option is succesfully updated
                                subcom = {"raidgroup1"};                        --The sub slash command and any aliases for this option
                                subhelp = PERL_CONF_RAID_GROUP1_DESC;           --The help text for the sub slash command
			};
                        --Register a checkbox, and a boolean sub slash command for Group 2
			{
                                hasbool = true;                                 --Whether this options has a boolean part
                                uivar = "PerlRaidGroup2";                       --The option name for the UI
                                uidep = { ["PerlRaidFrames"] = { checked = true } };
                                uitype = K_TEXT;                                --The option type for the UI
                                uilabel = PERL_CONF_RAID_GROUP2;                --The label to use for the checkbox in the UI
                                uidesc = PERL_CONF_RAID_GROUP2_DESC;            --The description to use for the checkbox in the UI
                                uidiff = 2;                                     --The difficulty of the option
                                varbool = "Perl_Config.ShowGroup2";             --The boolean variable associate with this option
                                uicheck = Perl_Config.ShowGroup2;               --The default value for the checkbox in the UI
                                update = Perl_OptionActions;                    --A command to perform when the option is succesfully updated
                                subcom = {"raidgroup2"};                        --The sub slash command and any aliases for this option
                                subhelp = PERL_CONF_RAID_GROUP2_DESC;           --The help text for the sub slash command
			};
                        --Register a checkbox, and a boolean sub slash command for Group 3
			{
                                hasbool = true;                                 --Whether this options has a boolean part
                                uivar = "PerlRaidGroup3";                       --The option name for the UI
                                uidep = { ["PerlRaidFrames"] = { checked = true } };
                                uitype = K_TEXT;                                --The option type for the UI
                                uilabel = PERL_CONF_RAID_GROUP3;                --The label to use for the checkbox in the UI
                                uidesc = PERL_CONF_RAID_GROUP3_DESC;            --The description to use for the checkbox in the UI
                                uidiff = 2;                                     --The difficulty of the option
                                varbool = "Perl_Config.ShowGroup3";             --The boolean variable associate with this option
                                uicheck = Perl_Config.ShowGroup3;               --The default value for the checkbox in the UI
                                update = Perl_OptionActions;                    --A command to perform when the option is succesfully updated
                                subcom = {"raidgroup3"};                        --The sub slash command and any aliases for this option
                                subhelp = PERL_CONF_RAID_GROUP3_DESC;           --The help text for the sub slash command
			};
                        --Register a checkbox, and a boolean sub slash command for Group 4
			{
                                hasbool = true;                                 --Whether this options has a boolean part
                                uivar = "PerlRaidGroup4";                       --The option name for the UI
                                uidep = { ["PerlRaidFrames"] = { checked = true } };
                                uitype = K_TEXT;                                --The option type for the UI
                                uilabel = PERL_CONF_RAID_GROUP4;                --The label to use for the checkbox in the UI
                                uidesc = PERL_CONF_RAID_GROUP4_DESC;            --The description to use for the checkbox in the UI
                                uidiff = 2;                                     --The difficulty of the option
                                varbool = "Perl_Config.ShowGroup4";             --The boolean variable associate with this option
                                uicheck = Perl_Config.ShowGroup4;               --The default value for the checkbox in the UI
                                update = Perl_OptionActions;                    --A command to perform when the option is succesfully updated
                                subcom = {"raidgroup4"};                        --The sub slash command and any aliases for this option
                                subhelp = PERL_CONF_RAID_GROUP4_DESC;           --The help text for the sub slash command
			};
                        --Register a checkbox, and a boolean sub slash command for Group 5
			{
                                hasbool = true;                                 --Whether this options has a boolean part
                                uivar = "PerlRaidGroup5";                       --The option name for the UI
                                uidep = { ["PerlRaidFrames"] = { checked = true } };
                                uitype = K_TEXT;                                --The option type for the UI
                                uilabel = PERL_CONF_RAID_GROUP5;                --The label to use for the checkbox in the UI
                                uidesc = PERL_CONF_RAID_GROUP5_DESC;            --The description to use for the checkbox in the UI
                                uidiff = 2;                                     --The difficulty of the option
                                varbool = "Perl_Config.ShowGroup5";             --The boolean variable associate with this option
                                uicheck = Perl_Config.ShowGroup5;               --The default value for the checkbox in the UI
                                update = Perl_OptionActions;                    --A command to perform when the option is succesfully updated
                                subcom = {"raidgroup5"};                        --The sub slash command and any aliases for this option
                                subhelp = PERL_CONF_RAID_GROUP5_DESC;           --The help text for the sub slash command
			};
                        --Register a checkbox, and a boolean sub slash command for Group 6
			{
                                hasbool = true;                                 --Whether this options has a boolean part
                                uivar = "PerlRaidGroup6";                       --The option name for the UI
                                uidep = { ["PerlRaidFrames"] = { checked = true } };
                                uitype = K_TEXT;                                --The option type for the UI
                                uilabel = PERL_CONF_RAID_GROUP6;                --The label to use for the checkbox in the UI
                                uidesc = PERL_CONF_RAID_GROUP6_DESC;            --The description to use for the checkbox in the UI
                                uidiff = 2;                                     --The difficulty of the option
                                varbool = "Perl_Config.ShowGroup6";             --The boolean variable associate with this option
                                uicheck = Perl_Config.ShowGroup6;               --The default value for the checkbox in the UI
                                update = Perl_OptionActions;                    --A command to perform when the option is succesfully updated
                                subcom = {"raidgroup6"};                        --The sub slash command and any aliases for this option
                                subhelp = PERL_CONF_RAID_GROUP6_DESC;           --The help text for the sub slash command
			};
                        --Register a checkbox, and a boolean sub slash command for Group 7
			{
                                hasbool = true;                                 --Whether this options has a boolean part
                                uivar = "PerlRaidGroup7";                       --The option name for the UI
                                uidep = { ["PerlRaidFrames"] = { checked = true } };
                                uitype = K_TEXT;                                --The option type for the UI
                                uilabel = PERL_CONF_RAID_GROUP7;                --The label to use for the checkbox in the UI
                                uidesc = PERL_CONF_RAID_GROUP7_DESC;            --The description to use for the checkbox in the UI
                                uidiff = 2;                                     --The difficulty of the option
                                varbool = "Perl_Config.ShowGroup7";             --The boolean variable associate with this option
                                uicheck = Perl_Config.ShowGroup7;               --The default value for the checkbox in the UI
                                update = Perl_OptionActions;                    --A command to perform when the option is succesfully updated
                                subcom = {"raidgroup7"};                        --The sub slash command and any aliases for this option
                                subhelp = PERL_CONF_RAID_GROUP7_DESC;           --The help text for the sub slash command
			};
                        --Register a checkbox, and a boolean sub slash command for Group 8
			{
                                hasbool = true;                                 --Whether this options has a boolean part
                                uivar = "PerlRaidGroup8";                       --The option name for the UI
                                uidep = { ["PerlRaidFrames"] = { checked = true } };
                                uitype = K_TEXT;                                --The option type for the UI
                                uilabel = PERL_CONF_RAID_GROUP8;                --The label to use for the checkbox in the UI
                                uidesc = PERL_CONF_RAID_GROUP8_DESC;            --The description to use for the checkbox in the UI
                                uidiff = 2;                                     --The difficulty of the option
                                varbool = "Perl_Config.ShowGroup8";             --The boolean variable associate with this option
                                uicheck = Perl_Config.ShowGroup8;               --The default value for the checkbox in the UI
                                update = Perl_OptionActions;                    --A command to perform when the option is succesfully updated
                                subcom = {"raidgroup8"};                        --The sub slash command and any aliases for this option
                                subhelp = PERL_CONF_RAID_GROUP8_DESC;           --The help text for the sub slash command
			};
                        --Register a checkbox, and a boolean sub slash command for Warrior Targets
			{
                                hasbool = true;                                 --Whether this options has a boolean part
                                uivar = "PerlRaidWarriorTargets";               --The option name for the UI
                                uidep = { ["PerlRaidFrames"] = { checked = true } };
                                uitype = K_TEXT;                                --The option type for the UI
                                uilabel = PERL_CONF_RAID_GROUP9;                --The label to use for the checkbox in the UI
                                uidesc = PERL_CONF_RAID_GROUP9_DESC;            --The description to use for the checkbox in the UI
                                uidiff = 2;                                     --The difficulty of the option
                                varbool = "Perl_Config.ShowGroup9";             --The boolean variable associate with this option
                                uicheck = Perl_Config.ShowGroup9;               --The default value for the checkbox in the UI
                                update = Perl_OptionActions;                    --A command to perform when the option is succesfully updated
                                subcom = {"raidwarriortargets", "rwt"};         --The sub slash command and any aliases for this option
                                subhelp = PERL_CONF_RAID_GROUP9_DESC;           --The help text for the sub slash command
			};
]]
		};
	} );
    end
end
