local Perl_Party_Events = {}
local thisid = nil;

----------------------
-- Loading Function --
----------------------

function Perl_Party_OnLoad()
	--Events
	this:RegisterEvent("PLAYER_ENTERING_WORLD");
	this:RegisterEvent("PLAYER_LEAVING_WORLD");

	getglobal("Perl_party"..this:GetID().."_DropDown"):SetID(this:GetID());
	table.insert(UnitPopupFrames,"Perl_party"..this:GetID().."_DropDown");

	getglobal("Perl_party"..this:GetID().."_NameFrame_CastClickOverlay"):SetFrameLevel(getglobal("Perl_party"..this:GetID().."_StatsFrame"):GetFrameLevel() + 2);
	getglobal("Perl_party"..this:GetID().."_TargetFrame_TargetCastClickOverlay"):SetFrameLevel(getglobal("Perl_party"..this:GetID().."_StatsFrame"):GetFrameLevel() + 2);

	HidePartyFrame();
	ShowPartyFrame=NewShowPartyFrame;

	this.PlayerFlash = 0;
	this.time = 0;
	--this.forceBuffRefresh = 0;
	this.feigning = 0;
	this.partyid = "party"..this:GetID();

	Perl_InitFadeFrame(this);
end
function NewShowPartyFrame()
	return;
end

local function Perl_Party_RegisterSome()
	this:RegisterEvent("PARTY_MEMBERS_CHANGED");
	this:RegisterEvent("PARTY_LEADER_CHANGED");
	this:RegisterEvent("PARTY_LOOT_METHOD_CHANGED");
	this:RegisterEvent("UNIT_PVP_UPDATE");
	this:RegisterEvent("UNIT_DYNAMIC_FLAGS");
	this:RegisterEvent("UNIT_FLAGS");
	this:RegisterEvent("UNIT_AURA");
	this:RegisterEvent("PARTY_MEMBER_ENABLE");
	this:RegisterEvent("PARTY_MEMBER_DISABLE");
	this:RegisterEvent("UNIT_SPELLMISS");
	Perl_RegisterBasics();
end
local function Perl_Party_UnregisterSome()
	this:UnregisterEvent("PARTY_MEMBERS_CHANGED");
	this:UnregisterEvent("PARTY_LEADER_CHANGED");
	this:UnregisterEvent("PARTY_LOOT_METHOD_CHANGED");
	this:UnregisterEvent("UNIT_PVP_UPDATE");
	this:UnregisterEvent("UNIT_DYNAMIC_FLAGS");
	this:UnregisterEvent("UNIT_FLAGS");
	this:UnregisterEvent("UNIT_AURA");
	this:UnregisterEvent("PARTY_MEMBER_ENABLE");
	this:UnregisterEvent("PARTY_MEMBER_DISABLE");
	this:UnregisterEvent("UNIT_SPELLMISS");
	Perl_UnregisterBasics();
end

local function Perl_Party_ShowPercentages()
	if (Perl_Config.ShowPartyPercent==1) then
		thisid = this:GetName();
		getglobal(thisid.."_StatsFrame"):SetWidth(136);
		getglobal(thisid.."_NameFrame_CastClickOverlay"):SetWidth(180);
	end
end

local function Perl_Party_HidePercentages(argReason)
	thisid = this:GetName();
	getglobal(thisid.."_StatsFrame"):SetWidth(106);
	getglobal(thisid.."_NameFrame_CastClickOverlay"):SetWidth(140);

	if (argReason) then
                getglobal(thisid.."_StatsFrame_HealthBar_HealthBarText"):SetText(argReason);
                getglobal(thisid.."_StatsFrame_ManaBar_ManaBarText"):Hide();
	end

        getglobal(thisid.."_StatsFrame_HealthBar_HealthBarPercentText"):Hide();
        getglobal(thisid.."_StatsFrame_ManaBar_ManaBarPercentText"):Hide();
end

local function Perl_Party_UpdateHealth()
	local numID = this:GetID();
	--partyid = ("party"..numID);
	thisid = this:GetName();
	local Partyhealth = UnitHealth(this.partyid);
	local Partyhealthmax = UnitHealthMax(this.partyid);
	local frameID = thisid.."_StatsFrame_"
	if ((this.feigning == 1) and (Partyhealth>1)) then
		this.feigning = 0;
	end
	if  (this.feigning == 1) then
                getglobal(frameID.."HealthBar"):SetMinMaxValues(0, 1);
                getglobal(frameID.."HealthBar"):SetValue(1);
                getglobal(frameID.."HealthBar"):SetStatusBarColor(0,1,0);
	else
                getglobal(frameID.."HealthBar"):SetMinMaxValues(0, Partyhealthmax);
                getglobal(frameID.."HealthBar"):SetValue(Partyhealth);
                Perl_SetSmoothBarColor(getglobal(frameID.."HealthBar"));
                Perl_SetSmoothBarColor(getglobal(frameID.."HealthBarBG"),getglobal(frameID.."HealthBar"), 0.25);
	end

	phealthPct = (Partyhealth * 100.0) / Partyhealthmax
	phealthPct = string.format("%3.0f", phealthPct);
        getglobal(frameID.."HealthBar_HealthBarPercentText"):SetText(string.format("%d",(100*(Partyhealth / Partyhealthmax))+0.5).."%");
        getglobal(frameID.."HealthBar_HealthBarPercentText"):Show();

	Perl_Party_ShowPercentages();

        getglobal(frameID.."HealthBar_HealthBarText"):SetText(Partyhealth.."/"..Partyhealthmax);

	if (not UnitIsConnected(this.partyid)) then
		Perl_Party_HidePercentages("Offline");
		this:SetAlpha(Perl_Config.Transparency/2);
		getglobal("Perl_Party_Pet"..numID):SetAlpha(Perl_Config.Transparency/2);
	else
		this:SetAlpha(Perl_Config.Transparency);
		getglobal("Perl_Party_Pet"..numID):SetAlpha(Perl_Config.Transparency);

		if (this.feigning == 1) then
			Perl_Party_HidePercentages("Feign Death");

		elseif (UnitIsDead(this.partyid)) then
			Perl_Party_HidePercentages("Dead");

		elseif (UnitIsGhost(this.partyid)) then
			Perl_Party_HidePercentages("Ghost");

		elseif ((Partyhealth==1) and (Partyhealthmax==1)) then
			Perl_Party_HidePercentages("Updating");
		end
	end

	if (Perl_Config.ShowPartyPercent==0) then
                getglobal(frameID.."ManaBar_ManaBarPercentText"):Hide();
                getglobal(frameID.."HealthBar_HealthBarPercentText"):Hide();
		Perl_Party_HidePercentages();
	end
end

--------------------
-- Buff Functions --
--------------------

local function Perl_Party_SetDebuffLoc()
	for i = 1,8 do
        	getglobal(thisid.."_BuffFrame_DeBuff"..i):ClearAllPoints();
	end

	if (Perl_Config.PartyDebuffsBelow==0) then
		if ((getglobal("Perl_Party_Pet"..this:GetID())):IsVisible()) then
			local offset;
			if (frame:IsShown()) then
				offset = getglobal("Perl_"..this.partyid.."_TargetFrame"):GetWidth() - 75;
			else
				offset = 75;
			end

                        getglobal(thisid.."_BuffFrame_DeBuff1"):SetPoint("LEFT", ("Perl_party"..this:GetID().."_StatsFrame"), "RIGHT", offset, 0);
		else
                        getglobal(thisid.."_BuffFrame_DeBuff1"):SetPoint("LEFT", ("Perl_party"..this:GetID().."_StatsFrame"), "RIGHT", 0, 0);
		end
	else
                getglobal(thisid.."_BuffFrame_DeBuff1"):SetPoint("TOPLEFT", ("Perl_party"..this:GetID().."_BuffFrame_Buff1"), "BOTTOMLEFT", 0, -2);
	end

	for i = 2,8 do
	        getglobal(thisid.."_BuffFrame_DeBuff"..i):SetPoint("TOPLEFT", ("Perl_party"..this:GetID().."_BuffFrame_DeBuff"..(i-1)), "TOPRIGHT", 1, 0);
	end
end

local function Perl_Party_Buff_UpdateAll ()
	--partyid = "party"..this:GetID();
	thisid = this:GetName();
	if (UnitName(this.partyid)) then
		local needUpdateHealth = false;
		Perl_Party_SetDebuffLoc();
		for buffnum=1,10 do
                        local button = getglobal(thisid.."_BuffFrame_Buff"..buffnum);
			local icon = getglobal(button:GetName().."Icon");
			local buff, count = UnitBuff(this.partyid, buffnum);
			if (buff) then
				icon:SetTexture(buff);
				if (strfind(strlower(buff), "feigndeath")) then
					if (this.feigning == 0) then
						this.feigning = 1;
						needUpdateHealth = true;
					end
				end
				local buffCount = getglobal(thisid.."_BuffFrame_Buff"..buffnum.."Count");
				if (count > 1) then
					buffCount:SetText(count);
					buffCount:Show();
				else
					buffCount:Hide();
				end
				button:Show();
			else
				button:Hide();
			end
		end
		for buffnum=1,8 do
                        local button = getglobal(thisid.."_BuffFrame_DeBuff"..(buffnum));
			local icon = getglobal(button:GetName().."Icon");
			local buff, count = UnitDebuff(this.partyid, buffnum);
			if (buff) then
				local type = GameTooltipTextRight1:GetText();
				icon:SetTexture(buff);

				local buffCount = getglobal(thisid.."_BuffFrame_Buff"..buffnum.."Count");
				if (count > 1) then
					buffCount:SetText(count);
					buffCount:Show();
				else
					buffCount:Hide();
				end
				button:Show();
			else
				button:Hide();
			end
		end

		if (needUpdateHealth) then
			Perl_Party_UpdateHealth();
		end
	end
end

function Perl_Party_SetBuffTooltip ()
	local partyid = "party"..this:GetParent():GetParent():GetID();
	GameTooltip:SetOwner(this,"ANCHOR_BOTTOMRIGHT",30,0);
	GameTooltip:SetUnitBuff(partyid, this:GetID());
	Perl_ToolTip_AddBuffDuration(partyid);
end

function Perl_ToolTip_AddBuffDuration(partyid)
	if (CT_RA_Stats) then
		local unitStats = CT_RA_Stats[UnitName(partyid)];
		if (unitStats) then
			local unitBuffs = unitStats["Buffs"];
			if (unitBuffs) then
				local temp = getglobal("GameTooltipTextLeft1");
				if (temp) then
					temp = temp:GetText();
					local buff = unitBuffs[temp];

					if (buff) then
						if (buff[2] and buff[2] > 0) then
							GameTooltip:AddLine(SecondsToTime(buff[2], true).."remaining", 1, 0.82, 0);
							GameTooltip:Show();
							return;
						end
					end
				end
			end
		end
	end
end

function Perl_Party_SetDeBuffTooltip ()
	local partyid = "party"..this:GetParent():GetParent():GetID();
	GameTooltip:SetOwner(this,"ANCHOR_BOTTOMRIGHT",30,0);
	GameTooltip:SetUnitDebuff(partyid, this:GetID());
	Perl_ToolTip_AddDebuffDuration(partyid);
end

function Perl_ToolTip_AddDebuffDuration(partyid)
	if (CT_RA_Stats) then
		local unitStats = CT_RA_Stats[UnitName(partyid)];
		if (unitStats) then
			local unitDebuffs = unitStats["Debuffs"];
			if (unitDebuffs) then
				local temp = getglobal("GameTooltipTextLeft1");
				if (temp) then
					temp = temp:GetText();
					local buff = unitDebuffs[temp];

					if (buff) then
						if (buff[2] and buff[2] > 0) then
							GameTooltip:AddLine(SecondsToTime(buff[2], true).."remaining", 1, 0.82, 0);
							GameTooltip:Show();
							return;
						end
					end
				end
			end
		end
	end
end


-------------------------
-- The Update Function --
-------------------------
local function Perl_Party_CombatFlash(elapsed, argNew, argGreen)
	if (Perl_CombatFlashSet (elapsed, this, argNew, argGreen)) then
		Perl_CombatFlashSetFrames(getglobal("Perl_"..this.partyid.."_NameFrame"), this.PlayerFlash, this.PlayerFlashGreen);
		Perl_CombatFlashSetFrames(getglobal("Perl_"..this.partyid.."_LevelFrame"), this.PlayerFlash, this.PlayerFlashGreen);
		Perl_CombatFlashSetFrames(getglobal("Perl_"..this.partyid.."_StatsFrame"), this.PlayerFlash, this.PlayerFlashGreen);
	end
end

local function Perl_Party_UpdateName()
	--partyid = ("party"..this:GetID());
	thisid = this:GetName();
	local Partyname = UnitName(this.partyid);
	if (Partyname) then
		if (strlen(Partyname) > 40) then
			Partyname = strsub(Partyname, 1, 39).."...";
		end
                if (Perl_Config.ShowPartyNames==1) then getglobal(thisid.."_NameFrame"):Show(); end
                getglobal(thisid.."_NameFrame_NameBarText"):SetText(Partyname);

		if (UnitIsEnemy("player", this.partyid)) then
                        getglobal(thisid.."_NameFrame_NameBarText"):SetTextColor(1,0,0);
		elseif (UnitIsPVP(this.partyid)) then
                        getglobal(thisid.."_NameFrame_NameBarText"):SetTextColor(0,1,0);
		else
                        getglobal(thisid.."_NameFrame_NameBarText"):SetTextColor(0.5,0.5,1);
		end
	end
end

local function Perl_Party_UpdateLeader()
	--partyid = ("party"..this:GetID());
	thisid = this:GetName();
	local id = this:GetID();
        local icon = getglobal(thisid.."_NameFrame_LeaderIcon");
	if (GetPartyLeaderIndex() == id ) then
		icon:Show();
	else
		icon:Hide();
	end
        icon = getglobal(thisid.."_NameFrame_MasterIcon");
	local lootMethod;
	local lootMaster;
	lootMethod, lootMaster = GetLootMethod();
	if ( id == lootMaster ) then
		icon:Show();
	else
		icon:Hide();
	end
end

local function Perl_Party_Update_Control()
        if (UnitIsVisible(this.partyid) and UnitIsCharmed(this.partyid)) then
		--Perl_Target_Warning:SetTexture("Interface\Minimap\Ping\ping6");
		--Perl_Target_Warning:SetBlendMode("ADD");
		getglobal(this:GetName().."_NameFrame_Warning"):Show();
	else
		getglobal(this:GetName().."_NameFrame_Warning"):Hide();
	end
end

function Perl_Party_UpdateCombat()
        Perl_Party_UpdateCombat1(this.partyid, this:GetName());
	Perl_Party_UpdateTarget();
	Perl_Party_Update_Control();
end

function Perl_Party_UpdateCombat1(argID,argName)
	local frame = getglobal(argName.."_NameFrame_ActivityStatus");
	if (not (frame == nil)) then
	        if (UnitName(argID) and UnitAffectingCombat(argID)) then
	                frame:SetTexCoord(0.5, 1.0, 0.0, 0.5);
	                frame:Show();
		else
	                frame:Hide();
		end
	end
end

local function Perl_Party_UpdatePVP()
	--partyid = ("party"..this:GetID());
	thisid = this:GetName();
	local f = getglobal(thisid.."_NameFrame_PVPStatus");
	if (UnitIsPVP(this.partyid)) then
		local p = "Interface\\TargetingFrame\\UI-PVP-";
		if (UnitFactionGroup(this.partyid) == "Alliance") then
                        f:SetTexture(p.."Alliance");
		elseif (UnitFactionGroup(this.partyid) == "Horde") then
                        f:SetTexture(p.."Horde");
		else
                        f:SetTexture(p.."FFA");
		end
                f:Show();
	else
                f:Hide();
	end
end

local function Perl_Party_UpdateLevel()
	--partyid = ("party"..this:GetID());
	thisid = this:GetName();
	local Partylevel = UnitLevel(this.partyid);
	local color = GetDifficultyColor(Partylevel);
        getglobal(thisid.."_LevelFrame_LevelBarText"):SetTextColor(color.r,color.g,color.b);
        getglobal(thisid.."_LevelFrame_LevelBarText"):SetText(Partylevel);
end

local function Perl_Party_UpdateClass()
	--partyid = ("party"..this:GetID());
	thisid = this:GetName();
	if (UnitIsPlayer(this.partyid)) then
		local PlayerClass = UnitClass(this.partyid);
                getglobal(thisid.."_LevelFrame_ClassTexture"):SetTexCoord(Perl_ClassPosRight(PlayerClass), Perl_ClassPosLeft(PlayerClass), Perl_ClassPosTop(PlayerClass), Perl_ClassPosBottom(PlayerClass));
	end
	if (Perl_Config.ShowPartyClassIcon==1) then
                getglobal(thisid.."_LevelFrame_ClassTexture"):Show();
	else
                getglobal(thisid.."_LevelFrame_ClassTexture"):Hide();
	end
end

local function Perl_Party_UpdateManaType()
	local frameName = this:GetName().."_StatsFrame_ManaBar";
	Perl_SetManaBarType(this.partyid, getglobal(frameName), getglobal(frameName.."BG"));
end

local function Perl_Party_UpdateMana()
	--partyid = ("party"..this:GetID());
	thisid = this:GetName();
	local Partymana = UnitMana(this.partyid);
	local Partymanamax = UnitManaMax(this.partyid);
	local frameManaBar = getglobal(thisid.."_StatsFrame_ManaBar");
	local frameManaBarText = getglobal(thisid.."_StatsFrame_ManaBar_ManaBarText");
	local frameManaBarPercentText = getglobal(thisid.."_StatsFrame_ManaBar_ManaBarPercentText");
	local frameHealthBarPercentText = getglobal(thisid.."_StatsFrame_HealthBar_HealthBarPercentText");

	if (Partymanamax == 1 and Partymana > Partymanamax) then
		Partymanamax = Partymana;
	end

        frameManaBar:SetMinMaxValues(0, Partymanamax);
        frameManaBar:SetValue(Partymana);
	pmanaPct = (Partymana * 100.0) / Partymanamax
	pmanaPct =  string.format("%3.0f", pmanaPct);
        if (frameHealthBarPercentText:IsVisible()) then
		frameManaBarPercentText:Show();
	end
	if (UnitPowerType(this.partyid)>=1) then
                frameManaBarPercentText:SetText(Partymana);
	else
                frameManaBarPercentText:SetText(string.format("%d",(100*(Partymana / Partymanamax))+0.5).."%");
	end
        frameManaBarText:Show();
        frameManaBarText:SetText(Partymana.."/"..Partymanamax);
	if (Perl_Config.ShowPartyPercent==0) then
                frameManaBarPercentText:Hide();
                frameHealthBarPercentText:Hide();
                getglobal(thisid.."_StatsFrame"):SetWidth(106);
                getglobal(thisid.."_NameFrame_CastClickOverlay"):SetWidth(140);
	end
	if (UnitIsConnected(this.partyid)) then
		this:SetAlpha(Perl_Config.Transparency);
		getglobal("Perl_Party_Pet"..this:GetID()):SetAlpha(Perl_Config.Transparency);
	else
		this:SetAlpha(Perl_Config.Transparency/2);
		getglobal("Perl_Party_Pet"..this:GetID()):SetAlpha(Perl_Config.Transparency/2);
                getglobal(thisid.."_StatsFrame_HealthBar_HealthBarText"):SetText("Offine");
	end
end

function Perl_Party_OnUpdate(elapsed)
        if (CastPartyConfig and (Perl_Config.CastPartyShow==0)) then
		CastPartyMainFrame:Hide();
	end

	if elapsed then
		thisid = this:GetName();
		--partyid = ("party"..id);

		Perl_Party_CombatFlash(elapsed, false);

		this.time = elapsed + this.time;
		if this.time >= 0.2 then
			Perl_Party_UpdateCombat();
			this.time=0;

			--this.forceBuffRefresh = this.forceBuffRefresh + 1;
			--if (this.forceBuffRefresh > 15) then
			--	Perl_Party_Buff_UpdateAll ();
			--	this.forceBuffRefresh = 0;
			--end
		end
	end

	Perl_ProcessFade(this);
end

local function Perl_Party_UpdateDisplay ()
	--partyid = ("party"..this:GetID());
	thisid=this:GetName();
	if (UnitName(this.partyid)) then
		Perl_CancelFade(this);

		Perl_Party_UpdateName();
		Perl_Party_UpdateLeader();
		Perl_Party_UpdatePVP();
		Perl_Party_UpdateClass();
		Perl_Party_UpdateManaType();
		Perl_Party_UpdateHealth();
		Perl_Party_UpdateMana();
		Perl_Party_UpdateLevel();
                Perl_Party_UpdateCombat();
		Perl_Party_Buff_UpdateAll ();

		if (UnitName("raid1")) then
			if (Perl_Config.ShowPartyRaid==1) then
				this:Show();
			elseif (Perl_Config.ShowPartyRaid==0) then
				--this:Hide();
				Perl_StartFade(this);
			end
		else
			this:Show();
		end

	else
		--getglobal("Perl_Party_Pet"..this:GetID()):Hide();
		--this:Hide();
		--this:StopMovingOrSizing();

		local framePet = getglobal("Perl_Party_Pet"..this:GetID());
		if (framePet:IsVisible()) then
			Perl_StartFade(framePet);
		end
		Perl_StartFade(this);

		if (UnitName(this.partyid) and not UnitIsConnected(this.partyid)) then
			this.FadeTime = 0.5;
			if (framePet:IsVisible()) then
				framePet.FadeTime = 0.5;
			end
		end
	end
end

--------------------
-- Click Handlers --
--------------------
local function Perl_Party_FindID(object)
	local name=object:GetName();
	if (strfind(name, "1")) then
		return 1;
	elseif (strfind(name, "2")) then
		return 2;
	elseif (strfind(name, "3")) then
		return 3;
	elseif (strfind(name, "4")) then
		return 4;
	else
		return nil;
	end
end

local function Perl_PartyDropDown_Initialize()
	local dropdown;
	local id = this:GetID();

	if (id == 0) then
		id = string.sub(this:GetName(), 11, 11);
		--this:SetID(id);
	end

	if ( UIDROPDOWNMENU_OPEN_MENU ) then
		dropdown = getglobal(UIDROPDOWNMENU_OPEN_MENU);
	else
		dropdown = this;
	end

	UnitPopup_ShowMenu(dropdown, "PARTY", "party"..id);
end

function Perl_PartyDropDown_OnLoad()
	UIDropDownMenu_Initialize(this, Perl_PartyDropDown_Initialize, "MENU");
end


function Perl_Party_OnClick(button,argTarget)
	local id=Perl_Party_FindID(this);
	this:SetID(id);

        if (not (CastPartyConfig and (Perl_Config.CastParty==1) and (strfind(this:GetName(), ("Perl_party"..id.."_StatsFrame"))))) then

		if ( SpellIsTargeting() and button == "RightButton" ) then
			SpellStopTargeting();
			return;
		end
		if ( button == "LeftButton" ) then
			if ( SpellIsTargeting() ) then
				if (argTarget == 0) then
					SpellTargetUnit("party"..id);
				else
					SpellTargetUnit("party"..id.."target");
				end
			elseif ( CursorHasItem() ) then
				if (argTarget == 0) then
					DropItemOnUnit("party"..id);
				else
					DropItemOnUnit("party"..id.."target");
				end
			else
				if (argTarget == 0) then
					TargetUnit("party"..id);
				else
					TargetUnit("party"..id.."target");
				end
			end
		else
			ToggleDropDownMenu(1, nil, getglobal("Perl_party"..id.."_DropDown"), this:GetName(), 0, 0);
		end
	end
        if (CastPartyConfig and (Perl_Config.CastParty==1) and (strfind(this:GetName(), ("Perl_party"..id.."_StatsFrame")))) then
		CastParty_OnClick(button);
	end
end
function Perl_Party_MouseUp(button)

	local id=Perl_Party_FindID(this);
	this:SetID(id);
	getglobal("Perl_party"..id):StopMovingOrSizing();
end

function Perl_Party_MouseDown(button)
	local id=Perl_Party_FindID(this);
	if ( button == "LeftButton" and perl_locked == 0) then
		getglobal("Perl_party"..id):StartMoving();
	end
end

function Perl_Party_PlayerTip()
	local id=Perl_Party_FindID(this);
	GameTooltip_SetDefaultAnchor(GameTooltip, this);
	GameTooltip:SetUnit("party"..id);
end

function Perl_Party_UpdateTarget()
	--local partyid = "party"..this:GetID();
	local frame = getglobal("Perl_"..this.partyid.."_TargetFrame");

	if (frame == nil) then
		return
	end
	if (frame.Fading == 1) then
		return;
	end

	if (Perl_Config.ShowPartyTarget == 0) then
		frame:SetWidth(68);
		frame:Hide();
		return;
	end

	local frameText = getglobal("Perl_"..this.partyid.."_TargetFrame_Target");
	if (UnitIsConnected(this.partyid) and UnitName(this.partyid) and UnitIsVisible(this.partyid)) then
		local unit = this.partyid.."target";

		if (UnitExists (unit)) then
			local targetname = UnitName(unit);
			frameText:SetText(targetname);
			local width = frameText:GetStringWidth();

			if (width < 68) then
				frame:SetWidth(68);
			elseif (width > 112) then
				frame:SetWidth(120);

				local remCount = 1;
				while ((frameText:GetStringWidth() >= 112) and (string.len(targetname) > remCount)) do
					targetname = string.sub(targetname, 1, string.len(targetname) - remCount).."..";
					remCount = 3;
					frameText:SetText(targetname);
				end
			else
				frame:SetWidth(width + 8);
			end

			Perl_SetUnitNameColor (unit, frameText);
			frame:Show();
			frame:SetAlpha(Perl_Config.Transparency);

			local frameAct = getglobal("Perl_"..this.partyid.."_TargetFrame_TargetActivityStatus");
		        if (UnitAffectingCombat(unit)) then
		                frameAct:SetTexCoord(0.5, 1.0, 0.0, 0.5);
		                frameAct:Show();
			else
		                frameAct:Hide();
			end

			local framePVP = getglobal("Perl_"..this.partyid.."_TargetFrame_TargetPVPStatus");
			if (UnitIsPVP(unit)) then
				local p = "Interface\\TargetingFrame\\UI-PVP-";
				if (UnitFactionGroup(unit) == "Alliance") then
					framePVP:SetTexture(p.."Alliance");
				elseif (UnitFactionGroup(unit) == "Horde") then
					framePVP:SetTexture(p.."Horde");
				else
					framePVP:SetTexture(p.."FFA");
				end
				framePVP:Show();
			else
				framePVP:Hide();
			end
		else
			frame:SetWidth(68);
			frame:SetAlpha(0);
			--frame:Hide();
		end
	else
		frame:SetWidth(68);
		frame:SetAlpha(0);
		--frame:Hide();
	end
end


-------------------
-- Event Handler --
-------------------
function Perl_Party_OnEvent()
	local func = Perl_Party_Events[event];
	if (func) then
		func();
	else
Perl_ShowMessage("EXTRA EVENT");
		--Perl_Party_UpdateDisplay();
	end
end

-- PLAYER_ENTERING_WORLD
function Perl_Party_Events:PLAYER_ENTERING_WORLD()
	Perl_Party_RegisterSome();
	Perl_Party_UpdateDisplay();
end
Perl_Party_Events.PARTY_MEMBERS_CHANGED		= Perl_Party_Events.PLAYER_ENTERING_WORLD;

-- PLAYER_LEAVING_WORLD()
function Perl_Party_Events:PLAYER_LEAVING_WORLD()
	Perl_Party_UnregisterSome();
end

-- PARTY_LEADER_CHANGED
function Perl_Party_Events:PARTY_LEADER_CHANGED()
	Perl_Party_UpdateLeader();
end

Perl_Party_Events.PARTY_LOOT_METHOD_CHANGED	= Perl_Party_Events.PARTY_LEADER_CHANGED;

-- UNIT_COMBAT
function Perl_Party_Events:UNIT_COMBAT()
	if (arg1 == this.partyid) then
		Perl_Party_UpdateCombat();

		if (arg2 == "HEAL") then
			Perl_Party_CombatFlash(0, true, true);
		elseif (arg4 and arg4 > 0) then
			Perl_Party_CombatFlash(0, true);
		end
	end
end

-- UNIT_SPELLMISS
function Perl_Party_Events:UNIT_SPELLMISS()
	if (arg1 == this.partyid) then
		Perl_Party_UpdateCombat();
	end
end

-- UNIT_HEALTH, UNIT_MAXHEALTH
function Perl_Party_Events:UNIT_HEALTH()
	if (arg1 == this.partyid) then
		Perl_Party_UpdateHealth();
	end
end

-- UNIT_MAXHEALTH
function Perl_Party_Events:UNIT_MAXHEALTH()
	if (arg1 == this.partyid) then
		Perl_Party_UpdateHealth();
		Perl_Party_UpdateLevel();	-- Level not available until we've received maxhealth
	end
end

Perl_Party_Events.PARTY_MEMBER_ENABLE	= Perl_Party_Events.UNIT_HEALTH;
Perl_Party_Events.PARTY_MEMBER_DISABLE	= Perl_Party_Events.UNIT_HEALTH;

-- UNIT_MANA
function Perl_Party_Events:UNIT_MANA()
	if (arg1 == this.partyid) then
		Perl_Party_UpdateMana();
        	Perl_Party_UpdateCombat();
	end
end

Perl_Party_Events.UNIT_MAXMANA		= Perl_Party_Events.UNIT_MANA;
Perl_Party_Events.UNIT_RAGE		= Perl_Party_Events.UNIT_MANA;
Perl_Party_Events.UNIT_MAXRAGE		= Perl_Party_Events.UNIT_MANA;
Perl_Party_Events.UNIT_ENERGY		= Perl_Party_Events.UNIT_MANA;
Perl_Party_Events.UNIT_MAXENERGY	= Perl_Party_Events.UNIT_MANA;
Perl_Party_Events.UNIT_FOCUS		= Perl_Party_Events.UNIT_MANA;
Perl_Party_Events.UNIT_MAXFOCUS		= Perl_Party_Events.UNIT_MANA;

-- UNIT_DISPLAYPOWER
function Perl_Party_Events:UNIT_DISPLAYPOWER()
	if (arg1 == this.partyid) then
		Perl_Party_UpdateManaType();
		Perl_Party_UpdateMana();
	end
end

-- UNIT_NAME_UPDATE
function Perl_Party_Events:UNIT_NAME_UPDATE()
	if (arg1 == this.partyid) then
		Perl_Party_UpdateName();
	end
end

-- UNIT_LEVEL
function Perl_Party_Events:UNIT_LEVEL()
	if (arg1 == this.partyid) then
		Perl_Party_UpdateLevel();
	end
end

-- UNIT_AURA
function Perl_Party_Events:UNIT_AURA()
	if (arg1 == this.partyid) then
		Perl_Party_Buff_UpdateAll();
		Perl_Party_UpdateCombat();
	end
end

-- UNIT_PVP_UPDATE
function Perl_Party_Events:UNIT_PVP_UPDATE()
	if (arg1 == this.partyid) then
		Perl_Party_UpdateName();
		Perl_Party_UpdatePVP();
		Perl_Party_UpdateCombat();
	end
end

Perl_Party_Events.UNIT_FLAGS = Perl_Party_Events.UNIT_PVP_UPDATE;
Perl_Party_Events.UNIT_DYNAMIC_FLAGS = Perl_Party_Events.UNIT_PVP_UPDATE;
