----------------------
-- Loading Function --
----------------------

function Perl_TargetTarget_OnLoad()
	-- Events
	Perl_TargetTarget_Frame:RegisterEvent("PLAYER_ENTERING_WORLD");
	Perl_TargetTarget_Frame:RegisterEvent("PLAYER_LEAVING_WORLD");

	Perl_TargetTarget_Frame:Hide();

	table.insert(UnitPopupFrames,"Perl_TargetTarget_DropDown");

	Perl_TargetTarget_Frame.time = 0;
	Perl_TargetTarget_Frame.targetname = "";
	Perl_TargetTarget_Frame.targethp = 0;
	Perl_TargetTarget_Frame.targetmana = 0;
	Perl_InitFadeFrame(Perl_TargetTarget_Frame);
end

local function Perl_TargetTarget_RegisterSome()
	this:RegisterEvent("PLAYER_TARGET_CHANGED");
end
local function Perl_TargetTarget_UnregisterSome()
	this:RegisterEvent("PLAYER_TARGET_CHANGED");
end

-------------------------
-- The Update Function --
-------------------------
function Perl_TargetTarget_UpdatePVP()
        local targetrankname, targetrank=GetPVPRankInfo(UnitPVPRank("targettarget"), "targettarget");
        if (targetrank and Perl_Config.ShowTargetPVPRank==1 and UnitIsPlayer("targettarget")) then
                Perl_TargetTarget_PVPRankIcon:Show();
		if (targetrank==0) then
                        Perl_TargetTarget_PVPRankIcon:Hide();
		elseif (targetrank>9) then
                        Perl_TargetTarget_PVPRankIcon:SetTexture("Interface\\PVPRankBadges\\PVPRank"..targetrank);
		else
                        Perl_TargetTarget_PVPRankIcon:SetTexture("Interface\\PVPRankBadges\\PVPRank0"..targetrank);
		end
	else
                Perl_TargetTarget_PVPRankIcon:Hide();
	end
        if (UnitIsPVP("targettarget")) then
		local p = "Interface\\TargetingFrame\\UI-PVP-";
                if (UnitFactionGroup("targettarget") == "Alliance") then
                        Perl_TargetTarget_PVPStatus:SetTexture(p.."Alliance");
                elseif (UnitFactionGroup("targettarget") == "Horde") then
                        Perl_TargetTarget_PVPStatus:SetTexture(p.."Horde");
		else
                        Perl_TargetTarget_PVPStatus:SetTexture(p.."FFA");
		end
                Perl_TargetTarget_PVPStatus:Show();
	else
                Perl_TargetTarget_PVPStatus:Hide();
	end
end

local function Perl_TargetTarget_Buff_UpdateAll()
	Perl_Targets_BuffUpdate("targettarget", "Perl_TargetTarget_");
end

local function Perl_TargetTarget_UpdateDisplay()
	local tt = "targettarget";
	if (perl_loaded and (UnitName("target")~=nil) and (Perl_Config.ShowTargetTarget==1) and (UnitIsConnected(tt))) then
		Perl_TargetTarget_Frame.targetname = UnitName(tt);
		if (Perl_TargetTarget_Frame.targetname ~= nil) then
			--Perl_TargetTarget_HistoryLast_NameBarText:SetText(Perl_TargetTarget_Frame.targetname);
			--Perl_TargetTarget_HistoryLast:Hide();

			Perl_CancelFade(Perl_TargetTarget_Frame);

			Perl_TargetTarget_Frame:Show();
	                Perl_TargetTarget_UpdatePVP();

			-- Save these 2, so we know whether to update the frame later
			Perl_TargetTarget_Frame.targethp = UnitHealth(tt);
			Perl_TargetTarget_Frame.targetmana = UnitMana(tt);

			Perl_TargetTarget_Frame:Show();

			-- Set name
			local TargetTargetname = Perl_TargetTarget_Frame.targetname;
			Perl_TargetTarget_NameBarText:SetText(TargetTargetname);

			local remCount = 1;
			while ((Perl_TargetTarget_NameBarText:GetStringWidth() >= (Perl_TargetTarget_NameFrame:GetWidth() - 8)) and (string.len(TargetTargetname) > remCount)) do
				TargetTargetname = string.sub(TargetTargetname, 1, string.len(TargetTargetname) - remCount).."..";
				remCount = 3;
				Perl_TargetTarget_NameBarText:SetText(TargetTargetname);
			end

                        Perl_SetUnitNameColor(tt, Perl_TargetTarget_NameBarText);

                        if (Perl_Config.ShowTargetLevel==1) then
				local TargetTargetlevel = UnitLevel(tt);

                                if (TargetTargetlevel < 0) then
                                        Perl_TargetTarget_LevelFrame:Hide();
                                else
                                        if (UnitIsPlusMob(tt)) then
                                                Perl_TargetTarget_LevelBarText:SetText(TargetTargetlevel.."+");
                                                Perl_TargetTarget_LevelFrame:SetWidth(33);
                                        else
                                                Perl_TargetTarget_LevelBarText:SetText(TargetTargetlevel);
                                                Perl_TargetTarget_LevelFrame:SetWidth(27);
                                        end
                                        Perl_TargetTarget_LevelFrame:Show();
                                end

	                        local color = GetDifficultyColor(TargetTargetlevel);
        	                Perl_TargetTarget_LevelBarText:SetTextColor(color.r, color.g, color.b);
                        else
                                Perl_TargetTarget_LevelFrame:Hide();
                        end

			-- Set health
			Perl_Target_SetHealth(tt, Perl_TargetTarget_HealthBar, Perl_TargetTarget_HealthBarBG, Perl_TargetTarget_HealthBarPercent, Perl_TargetTarget_HealthBarText, Perl_TargetTarget_ManaBarPercent);

			-- Set mana
			Perl_Target_SetManaType(tt, Perl_TargetTarget_ManaBar, Perl_TargetTarget_ManaBarText, Perl_TargetTarget_ManaBarBG, Perl_TargetTarget_StatsFrame, Perl_TargetTarget_Frame);
			Perl_Target_SetMana(tt, Perl_TargetTarget_ManaBar, Perl_TargetTarget_HealthBarPercent, Perl_TargetTarget_ManaBarPercent, Perl_TargetTarget_ManaBarText);

			Perl_TargetTarget_Buff_UpdateAll();

			return;
		else
			Perl_TargetTarget_Frame.targetname = "";
		end
	else
		Perl_TargetTarget_Frame.targetname = "";
	end

	Perl_StartFade(Perl_TargetTarget_Frame);

	--Perl_TargetTarget_Frame:Hide();
	--Perl_TargetTarget_Frame:StopMovingOrSizing();
end

local function Perl_TargetTarget_Update_Control()
        if (UnitIsVisible("targettarget") and UnitIsCharmed("targettarget")) then
		Perl_TargetTarget_Warning:Show();
	else
		Perl_TargetTarget_Warning:Hide();
	end
end

local function Perl_TargetTarget_Update_Combat()
        if (UnitAffectingCombat("targettarget")) then
                Perl_TargetTarget_ActivityStatus:SetTexCoord(0.5, 1.0, 0.0, 0.5);
                Perl_TargetTarget_ActivityStatus:Show();
        else
                Perl_TargetTarget_ActivityStatus:Hide();
        end
end

local function Perl_TargetTarget_AddHistory(newName, r, g, b)
	if (table.getn(Perl_TargetHistory) == 0 or newName ~= Perl_TargetHistory[1].name) then
		table.insert(Perl_TargetHistory, 1, {["name"] = newName, ["r"] = r, ["g"] = g, ["b"] = b, ["time"] = GetTime()});

		while (table.getn(Perl_TargetHistory) > 10) do
			table.remove(Perl_TargetHistory, 11);
		end
		Perl_TargetTarget_Frame.FlashChangeStart = GetTime();
	end
end

function Perl_TargetTarget_OnUpdate(elapsed)
	local newName = UnitName("targettarget");
	local newHP = UnitHealth("targettarget");
	local newMana = UnitMana("targettarget");

	if (not newName) then
		newName = "";
		newHP = 0;
		newMana = 0;
	end

	if (newName ~= Perl_TargetTarget_Frame.targetname) then
		--if (newName == "") then
		--	Perl_TargetTarget_ClearHistory();
		--else
			if (not UnitIsUnit("player", "target")) then
				if (Perl_TargetTarget_Frame.targetname ~= "") then
					if (newName ~= "") then
						local r, g, b = Perl_TargetTarget_NameBarText:GetTextColor();
						Perl_TargetTarget_AddHistory(Perl_TargetTarget_Frame.targetname, r, g, b);
					end
				end
			end
		--end

		Perl_TargetTarget_UpdateDisplay();
	elseif ((newHP ~= Perl_TargetTarget_Frame.targethp) or (newMana ~= Perl_TargetTarget_Frame.targetmana)) then
		Perl_TargetTarget_UpdateDisplay();
	end

	if (Perl_Config.TargetTargetHistory == 1) then
		Perl_TargetTarget_Update();
	else
		Perl_TargetTarget_HideHistory();
	end

	Perl_TargetTarget_Frame.time = elapsed + Perl_TargetTarget_Frame.time;
        if Perl_TargetTarget_Frame.time >= 0.3 then
		if (newName ~= "") then
	                Perl_TargetTarget_Update_Combat();
			Perl_TargetTarget_Update_Control();
	                Perl_TargetTarget_UpdatePVP();
			Perl_TargetTarget_Buff_UpdateAll();
			Perl_SetUnitNameColor("targettarget", Perl_TargetTarget_NameBarText);
		end

		Perl_TargetTarget_Frame.time = 0;
	end

	Perl_ProcessFade(Perl_TargetTarget_Frame);
end

--------------------
-- Click Handlers --
--------------------

function Perl_TargetTarget_PlayerTip()
	GameTooltip_SetDefaultAnchor(GameTooltip, this);
	GameTooltip:SetUnit("targettarget");
end

function Perl_TargetTargetDropDown_OnLoad()
	UIDropDownMenu_Initialize(this, Perl_TargetTargetDropDown_Initialize, "MENU");
end

function Perl_TargetTargetDropDown_Initialize()
	local menu = nil;
	if ( UnitIsEnemy("targettarget", "player") ) then
		return;
	end
	if ( UnitIsUnit("targettarget", "player") ) then
		menu = "SELF";
	elseif ( UnitIsUnit("targettarget", "pet") ) then
		menu = "PET";
	elseif ( UnitIsPlayer("targettarget") ) then
		if ( UnitInParty("targettarget") ) then
			menu = "PARTY";
		else
			menu = "PLAYER";
		end
	end
	if ( menu ) then
		UnitPopup_ShowMenu(Perl_TargetTarget_DropDown, menu, "targettarget");
	end
end

function Perl_TargetTarget_MouseUp(button)
	if ( SpellIsTargeting() and button == "RightButton" ) then
		SpellStopTargeting();
		return;
	end
	if ( button == "LeftButton" ) then
		if ( SpellIsTargeting() ) then
			SpellTargetUnit("targettarget");
		elseif ( CursorHasItem() ) then
			DropItemOnUnit("targettarget");
		else
			TargetUnit("targettarget");
		end
	else
		ToggleDropDownMenu(1, nil, Perl_TargetTarget_DropDown, "Perl_TargetTarget_NameFrame", 40, -25);
	end

	Perl_TargetTarget_Frame:StopMovingOrSizing();
end

function Perl_TargetTarget_MouseDown(button)
	if ( button == "LeftButton" and perl_locked == 0) then
		Perl_TargetTarget_Frame:StartMoving();
	end
end

-------------------
-- Event Handler --
-------------------
function Perl_TargetTarget_OnEvent()
	if (event == "PLAYER_ENTERING_WORLD") then
		Perl_TargetTarget_RegisterSome();
	elseif (event == "PLAYER_LEAVING_WORLD") then
		Perl_TargetTarget_RegisterSome();
		return;
	end

	if (unit) then
		if (unit=="target" or unit=="targettarget") then
			Perl_TargetTarget_UpdateDisplay();		-- Never happens
		end
	else
		Perl_TargetTarget_UpdateDisplay();
	end
end

--------------------
-- Target history --
--------------------

Perl_TargetHistory = {}

local function Process_HistoryFlash()
	if (not Perl_TargetTarget_Frame.FlashChangeStart) then
		return;
	end

	local timer = (GetTime() - Perl_TargetTarget_Frame.FlashChangeStart);
	local r, g, b;
	if (timer > 1) then
		Perl_TargetTarget_Frame.FlashChangeStart = nil;
		r = Perl_Config.BorderColour.r;
		g = Perl_Config.BorderColour.g;
		b = Perl_Config.BorderColour.b;
	else
		r = Perl_Config.BorderColour.r + 0.5 - (timer / 2);
		g = Perl_Config.BorderColour.g + 0.5 - (timer / 2);
		b = Perl_Config.BorderColour.b + 0.5 - (timer / 2);

		if (r < 0) then r = 0; elseif (r > 1) then r = 1; end
		if (g < 0) then g = 0; elseif (g > 1) then g = 1; end
		if (b < 0) then b = 0; elseif (b > 1) then b = 1; end

		--r = 1 - (timer / 2);
		--g = r;
		--b = r;
	end

	Perl_TargetTarget_NameFrame:SetBackdropBorderColor(r, g, b, 1);
	Perl_TargetTarget_StatsFrame:SetBackdropBorderColor(r, g, b, 1);
	Perl_TargetTarget_LevelFrame:SetBackdropBorderColor(r, g, b, 1);
	Perl_TargetTarget_History1:SetBackdropBorderColor(r, g, b, 1);
end

function Perl_TargetTarget_ClearHistory()
	--Perl_TargetTarget_HistoryLast_NameBarText:SetText("");
	Perl_TargetHistory = {}
	Perl_TargetTarget_Update();
	Perl_TargetTarget_HistoryLast:Hide();
end

function Perl_TargetTarget_Update()

	local alpha = Perl_Config.Transparency;
	local time = GetTime();

	Process_HistoryFlash();

	local offset = -3;
	if (UnitName("targettarget")) then
		if (UnitBuff("targettarget", 1)) then
			offset = offset + 20;
			if (UnitBuff("targettarget", 9)) then
				offset = offset + 20;
			end
		end
		if (UnitDebuff("targettarget", 1)) then
			offset = offset + 24;
		end
	end
	Perl_TargetTarget_History1:ClearAllPoints();
	Perl_TargetTarget_History1:SetPoint("TOPLEFT", Perl_TargetTarget_StatsFrame, "BOTTOMLEFT", 0, -offset);

	for i = 1,10 do
		local frame = getglobal("Perl_TargetTarget_History"..i);
		local frameText = getglobal("Perl_TargetTarget_History"..i.."_NameBarText");
		local value = Perl_TargetHistory[i];

		if (value) then
			frameText:SetText(Perl_TargetHistory[i].name);
			frameText:SetTextColor(Perl_TargetHistory[i].r, Perl_TargetHistory[i].g, Perl_TargetHistory[i].b);
			frame:Show();

			local minAlpha = 0.2;
			local fadeSeconds = 9;
			if (Perl_TargetHistory[i].time < time - (fadeSeconds + 1)) then
				frame:SetAlpha(minAlpha);
			elseif (Perl_TargetHistory[i].time < time - fadeSeconds) then
				local fullRange = Perl_Config.Transparency - minAlpha;
				local fade = (time - Perl_TargetHistory[i].time) - fadeSeconds;
				local alphaItem = Perl_Config.Transparency - (fullRange * fade);

				frame:SetAlpha(alphaItem);
			else
				frame:SetAlpha(Perl_Config.Transparency);
			end

		else
			--frameText:SetText("Error!");
			frame:Hide();
		end
	end

	--if (not UnitName("targettarget")) then -- and table.getn(Perl_TargetHistory) > 0) then
	--	if (Perl_TargetTarget_HistoryLast_NameBarText:GetText() ~= "") then
	--		Perl_TargetTarget_HistoryLast:Show();
	--		Perl_TargetTarget_HistoryLast:SetAlpha(0.2);
	--	end
	--end
end

function Perl_TargetTarget_ResetFade()
	local time = GetTime();
	for i = 1,table.getn(Perl_TargetHistory) do
		Perl_TargetHistory[i].time = time;
	end
end

function Perl_TargetTarget_History_OnEnter()
	local id = this:GetID();
	if (id) then
		Perl_TargetHistory[id].time = GetTime();
	end
end

function Perl_TargetTarget_History_OnMouseUp()
	local id = this:GetID();

	if (id) then
		if (Perl_TargetHistory[id].name) then
			TargetByName(Perl_TargetHistory[id].name);
		end
	end
end

function Perl_TargetTarget_HideHistory()
	for i = 1,10 do
		getglobal("Perl_TargetTarget_History"..i):Hide();
	end
end
